import { FC } from 'react';
import { ILetterItem, IAvatarProps } from '../types.mjs';
import 'leaflet';

/**
 * Convert string to a random colour
 * @param str The string to convert
 * @return string The random colour
 */
declare const stringToColor: (str: string) => string;
/**
 * Returns the first two letters of the name
 * @param letterItem The ILetterItem to get the name from
 * @param title The title to get the name from (used as fallback)
 */
declare function getAvatarLetters(letterItem: ILetterItem | undefined, title: string | undefined): string;
declare const LetterAvatar: FC<IAvatarProps>;

export { LetterAvatar, getAvatarLetters, stringToColor };
