"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/Avatar/LetterAvatar.tsx
var LetterAvatar_exports = {};
__export(LetterAvatar_exports, {
  LetterAvatar: () => LetterAvatar,
  getAvatarLetters: () => getAvatarLetters,
  stringToColor: () => stringToColor
});
module.exports = __toCommonJS(LetterAvatar_exports);
var import_jsx_runtime = require("react/jsx-runtime");
var stringToColor = (str) => {
  let hash = 0;
  for (let i = 0; i < str.length; i++) {
    hash = str.charCodeAt(i) + ((hash << 5) - hash);
  }
  let colour = "#";
  for (let i = 0; i < 3; i++) {
    let value = hash >> i * 8 & 255;
    value = value % 150 + 50;
    colour += `00${value.toString(16)}`.substr(-2);
  }
  return colour;
};
function getAvatarLetters(letterItem, title) {
  let name = "U";
  if (letterItem == null ? void 0 : letterItem.letter) {
    name = letterItem.letter;
  }
  if (title) {
    name = title;
  }
  return name.toUpperCase().split(" ").map((w) => w[0]).slice(0, 2).join("");
}
var LetterAvatar = (props) => {
  var _a, _b, _c;
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    "div",
    {
      className: "rce-avatar rce-avatar-letter-background",
      style: {
        backgroundColor: stringToColor(
          (_c = (_b = (_a = props.letterItem) == null ? void 0 : _a.id) != null ? _b : props == null ? void 0 : props.title) != null ? _c : "unknown"
        )
      },
      children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        "svg",
        {
          role: "img",
          xmlns: "http://www.w3.org/2000/svg",
          viewBox: "0 0 50 50",
          className: "rce-avatar-letter",
          children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
            "text",
            {
              fill: "white",
              fontSize: "25",
              x: "50%",
              y: "50%",
              dominantBaseline: "central",
              textAnchor: "middle",
              children: getAvatarLetters(props == null ? void 0 : props.letterItem, props == null ? void 0 : props.title)
            }
          )
        }
      )
    }
  );
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  LetterAvatar,
  getAvatarLetters,
  stringToColor
});
