"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/ChatList/ChatList.tsx
var ChatList_exports = {};
__export(ChatList_exports, {
  default: () => ChatList_default
});
module.exports = __toCommonJS(ChatList_exports);
var import_classnames6 = __toESM(require("classnames"));

// src/Avatar/Avatar.tsx
var import_classnames = __toESM(require("classnames"));

// src/Avatar/LetterAvatar.tsx
var import_jsx_runtime = require("react/jsx-runtime");
var stringToColor = (str) => {
  let hash = 0;
  for (let i = 0; i < str.length; i++) {
    hash = str.charCodeAt(i) + ((hash << 5) - hash);
  }
  let colour = "#";
  for (let i = 0; i < 3; i++) {
    let value = hash >> i * 8 & 255;
    value = value % 150 + 50;
    colour += `00${value.toString(16)}`.substr(-2);
  }
  return colour;
};
function getAvatarLetters(letterItem, title) {
  let name = "U";
  if (letterItem == null ? void 0 : letterItem.letter) {
    name = letterItem.letter;
  }
  if (title) {
    name = title;
  }
  return name.toUpperCase().split(" ").map((w) => w[0]).slice(0, 2).join("");
}
var LetterAvatar = (props) => {
  var _a, _b, _c;
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    "div",
    {
      className: "rce-avatar rce-avatar-letter-background",
      style: {
        backgroundColor: stringToColor(
          (_c = (_b = (_a = props.letterItem) == null ? void 0 : _a.id) != null ? _b : props == null ? void 0 : props.title) != null ? _c : "unknown"
        )
      },
      children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        "svg",
        {
          role: "img",
          xmlns: "http://www.w3.org/2000/svg",
          viewBox: "0 0 50 50",
          className: "rce-avatar-letter",
          children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
            "text",
            {
              fill: "white",
              fontSize: "25",
              x: "50%",
              y: "50%",
              dominantBaseline: "central",
              textAnchor: "middle",
              children: getAvatarLetters(props == null ? void 0 : props.letterItem, props == null ? void 0 : props.title)
            }
          )
        }
      )
    }
  );
};

// src/Avatar/Avatar.tsx
var import_jsx_runtime2 = require("react/jsx-runtime");
var Avatar = (_a) => {
  var _b = _a, {
    size = "default",
    rounded = true
  } = _b, props = __objRest(_b, [
    "size",
    "rounded"
  ]);
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(
    "div",
    {
      className: (0, import_classnames.default)(
        "rce-avatar-container",
        size,
        props == null ? void 0 : props.className,
        rounded && "rounded"
      ),
      style: props == null ? void 0 : props.style,
      children: [
        props.letterItem || !(props == null ? void 0 : props.src) ? /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(LetterAvatar, __spreadValues({}, props)) : /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
          "img",
          {
            loading: "lazy",
            alt: props == null ? void 0 : props.alt,
            src: props.src,
            className: "rce-avatar"
          }
        ),
        props == null ? void 0 : props.sideElement
      ]
    }
  );
};
var Avatar_default = Avatar;

// src/ChatItem/ChatItem.tsx
var import_classnames5 = __toESM(require("classnames"));
var import_md2 = require("react-icons/md");
var import_fa = require("react-icons/fa");
var import_react2 = require("react");

// src/MeetingItem/MeetingItem.tsx
var import_md = require("react-icons/md");
var import_date_fns = require("date-fns");
var import_classnames2 = __toESM(require("classnames"));
var import_react = require("react");
var import_jsx_runtime3 = require("react/jsx-runtime");
var relativeDateFormat = (date = /* @__PURE__ */ new Date()) => {
  let dateObject;
  try {
    if (date instanceof Date) {
      dateObject = date;
    } else {
      dateObject = new Date(date);
    }
  } catch (error) {
    dateObject = /* @__PURE__ */ new Date();
    console.error("the date provided is not valid", error);
  }
  return (0, import_date_fns.formatDistance)(dateObject, /* @__PURE__ */ new Date(), {
    addSuffix: true
  }).replace("less than a minute ago", "now");
};

// src/Button/Button.tsx
var import_classnames3 = __toESM(require("classnames"));
var import_jsx_runtime4 = require("react/jsx-runtime");
var ButtonIcon = (props) => {
  var _a;
  return /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("span", { className: "rce-button-icon--container", children: /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(
    "span",
    {
      style: {
        float: (_a = props.float) != null ? _a : "inherit",
        fontSize: props.size || 12
      },
      className: "rce-button-icon",
      children: props.component
    }
  ) });
};
var Button = (_a) => {
  var _b = _a, {
    backgroundColor = "var(--rce-color-secondary)",
    color = "var(--rce-color-white)",
    style = {},
    borderWidth = 2,
    outlined,
    disabled,
    circle,
    squared,
    link,
    icon,
    buttonRef,
    text,
    className,
    children
  } = _b, rest = __objRest(_b, [
    "backgroundColor",
    "color",
    "style",
    "borderWidth",
    "outlined",
    "disabled",
    "circle",
    "squared",
    "link",
    "icon",
    "buttonRef",
    "text",
    "className",
    "children"
  ]);
  var _a2;
  return /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)(
    "button",
    __spreadProps(__spreadValues({
      type: (_a2 = rest.type) != null ? _a2 : "button",
      ref: buttonRef,
      className: (0, import_classnames3.default)(
        "rce-button",
        className,
        outlined && "outlined",
        circle && "circle",
        link && "link",
        squared && "squared",
        disabled && "disabled"
      ),
      style: __spreadValues({
        backgroundColor: outlined ? color : backgroundColor,
        color: outlined ? backgroundColor : color,
        borderColor: backgroundColor,
        borderWidth,
        flexDirection: (icon == null ? void 0 : icon.float) === "left" ? "row-reverse" : "row"
      }, style)
    }, rest), {
      children: [
        children,
        text && /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("span", { children: text }),
        (icon == null ? void 0 : icon.component) && /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(ButtonIcon, __spreadValues({}, icon))
      ]
    })
  );
};
var Button_default = Button;

// src/Badge/Badge.tsx
var import_classnames4 = __toESM(require("classnames"));
var import_jsx_runtime5 = require("react/jsx-runtime");
var Badge = (props) => {
  var _a, _b;
  const { rounded = true } = props;
  return /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(
    "span",
    {
      style: __spreadProps(__spreadValues({}, props.style), {
        color: (props == null ? void 0 : props.color) || "var(--rce-color-white)",
        backgroundColor: (props == null ? void 0 : props.backgroundColor) || "var(--rce-color-red)",
        fontSize: (props == null ? void 0 : props.size) || 11,
        aspectRatio: rounded ? "1/1" : void 0,
        borderRadius: rounded ? "100%" : "5px",
        position: (props == null ? void 0 : props.position) ? "absolute" : void 0
      }),
      className: (0, import_classnames4.default)(
        "rce-badge",
        props.className,
        props.position ? (_a = props.position) == null ? void 0 : _a.split("-").join(" ") : void 0
      ),
      children: (props == null ? void 0 : props.value) ? (_b = props == null ? void 0 : props.value) == null ? void 0 : _b.toString() : null
    }
  );
};
var Badge_default = Badge;

// src/ChatItem/ChatItem.tsx
var import_jsx_runtime6 = require("react/jsx-runtime");
var import_react3 = require("react");
var ChatItem = (_a) => {
  var _b = _a, {
    date = /* @__PURE__ */ new Date()
  } = _b, props = __objRest(_b, [
    "date"
  ]);
  var _a2, _b2, _c, _d;
  const [isExpanded, setIsExpanded] = (0, import_react2.useState)(
    props.expanded || false
  );
  function getStatusItem() {
    var _a3;
    if ((props == null ? void 0 : props.statusColorType) === "badge") {
      return /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(
        Badge_default,
        {
          backgroundColor: props == null ? void 0 : props.statusColor,
          value: props == null ? void 0 : props.statusText,
          position: "top-right"
        }
      );
    }
    if ((props == null ? void 0 : props.statusColorType) === "encircle") {
      return /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(
        "span",
        {
          className: "rce-citem-status encircle",
          style: {
            borderColor: (_a3 = props == null ? void 0 : props.statusColor) != null ? _a3 : "var(--rce-color-green)"
          }
        }
      );
    }
    return null;
  }
  return /* @__PURE__ */ (0, import_jsx_runtime6.jsx)("div", { className: (0, import_classnames5.default)("rce-container-citem", props.className), children: /* @__PURE__ */ (0, import_jsx_runtime6.jsxs)("div", { className: "rce-citem", children: [
    /* @__PURE__ */ (0, import_jsx_runtime6.jsxs)(
      "div",
      {
        className: (0, import_classnames5.default)("rce-citem-avatar", {
          "rce-citem-status-encircle": (props == null ? void 0 : props.statusColorType) === "encircle"
        }),
        children: [
          /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(
            Avatar_default,
            {
              src: props == null ? void 0 : props.avatar,
              alt: props.alt,
              title: props.title,
              className: (props == null ? void 0 : props.statusColorType) === "encircle" ? "rce-citem-avatar-encircle-status" : void 0,
              size: props.avatarSize || "default",
              letterItem: props.letterItem,
              sideElement: getStatusItem(),
              onError: props.onAvatarError,
              type: (0, import_classnames5.default)("circle", {
                flexible: (props == null ? void 0 : props.avatarFlexible) === true
              })
            }
          ),
          ((_a2 = props == null ? void 0 : props.subList) == null ? void 0 : _a2.length) && /* @__PURE__ */ (0, import_jsx_runtime6.jsxs)(import_jsx_runtime6.Fragment, { children: [
            /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(
              Button_default,
              {
                link: true,
                className: "rce-citem-expand-button",
                onClick: () => setIsExpanded(!isExpanded),
                icon: {
                  component: isExpanded ? /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(import_fa.FaArrowUp, {}) : /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(import_fa.FaArrowDown, {})
                }
              }
            ),
            /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(
              "div",
              {
                className: "mce-citem-sublist",
                style: { display: props.expanded ? "block" : "none" },
                children: (_b2 = props.subList) == null ? void 0 : _b2.map((sub, i) => /* @__PURE__ */ (0, import_react3.createElement)(
                  ChatItem,
                  __spreadProps(__spreadValues({}, sub), {
                    className: "subitem",
                    avatarSize: "xsmall",
                    key: `subitem-${i.toString()}`
                  })
                ))
              }
            )
          ] })
        ]
      }
    ),
    /* @__PURE__ */ (0, import_jsx_runtime6.jsxs)("div", { className: "rce-citem-body", children: [
      /* @__PURE__ */ (0, import_jsx_runtime6.jsxs)("div", { className: "rce-citem-body--top", children: [
        /* @__PURE__ */ (0, import_jsx_runtime6.jsx)("div", { className: "rce-citem-body--top-title", children: props.title }),
        /* @__PURE__ */ (0, import_jsx_runtime6.jsx)("div", { className: "rce-citem-body--top-time", children: date && (props.dateString || relativeDateFormat(date)) })
      ] }),
      /* @__PURE__ */ (0, import_jsx_runtime6.jsxs)("div", { className: "rce-citem-body--bottom", children: [
        /* @__PURE__ */ (0, import_jsx_runtime6.jsx)("div", { className: "rce-citem-body--bottom-title", children: props.subtitle }),
        /* @__PURE__ */ (0, import_jsx_runtime6.jsxs)("div", { className: "rce-citem-body--bottom-elements", children: [
          /* @__PURE__ */ (0, import_jsx_runtime6.jsxs)(
            "div",
            {
              className: "rce-citem-body--bottom-tools",
              onMouseEnter: props == null ? void 0 : props.handleOnMouseEnter,
              onMouseLeave: props == null ? void 0 : props.handleOnMouseLeave,
              children: [
                props.showMute ? /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(
                  Button_default,
                  {
                    link: true,
                    className: "rce-citem-body--bottom-tools-item",
                    onClick: (ev) => {
                      var _a3;
                      return (_a3 = props == null ? void 0 : props.onMuteToggle) == null ? void 0 : _a3.call(props, ev, props);
                    },
                    icon: {
                      component: (props == null ? void 0 : props.muted) ? /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(import_md2.MdVolumeOff, {}) : /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(import_md2.MdVolumeUp, {})
                    }
                  }
                ) : null,
                (props == null ? void 0 : props.showVideoCall) ? /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(
                  Button_default,
                  {
                    link: true,
                    className: "rce-citem-body--bottom-tools-item",
                    onClick: (ev) => {
                      var _a3;
                      return (_a3 = props == null ? void 0 : props.onVideoCall) == null ? void 0 : _a3.call(props, ev, props);
                    },
                    icon: { component: /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(import_md2.MdVideoCall, {}) }
                  }
                ) : null
              ]
            }
          ),
          /* @__PURE__ */ (0, import_jsx_runtime6.jsx)("div", { className: "rce-citem-body--bottom-tools-item-hidden-hover", children: (props == null ? void 0 : props.showMute) && (props == null ? void 0 : props.muted) && /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(
            Button_default,
            {
              link: true,
              className: "rce-citem-body--bottom-tools-item",
              onClick: (e) => {
                var _a3;
                return (_a3 = props == null ? void 0 : props.onMuteToggle) == null ? void 0 : _a3.call(props, e, props);
              },
              children: /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(import_md2.MdVolumeOff, {})
            }
          ) }),
          (props == null ? void 0 : props.unread) ? /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(
            Badge_default,
            {
              className: "rce-citem-body--bottom-status",
              value: props.unread
            }
          ) : null,
          (_d = (_c = props == null ? void 0 : props.customStatusComponents) == null ? void 0 : _c.map(
            (el, index) => {
              return (0, import_react2.cloneElement)(el, { key: index.toString() });
            }
          )) != null ? _d : null
        ] })
      ] })
    ] }, "rce-citem-body")
  ] }) });
};
var ChatItem_default = ChatItem;

// src/Loader/Loader.tsx
var import_react4 = require("react");
var import_progressbar = require("progressbar.js");
var import_jsx_runtime7 = require("react/jsx-runtime");
var Loader = ({
  type = "circle",
  progressOptions = {
    strokeWidth: 6,
    easing: "easeInOut",
    duration: 1400,
    color: "#0791f1",
    trailColor: "#eee"
  },
  className,
  size = 100,
  progress = 0,
  style = {}
}) => {
  const wrapperRef = (0, import_react4.useRef)(null);
  const loaderRef = (0, import_react4.useRef)(null);
  const createWrapper = () => {
    const wrapper2 = document.createElement("div");
    wrapperRef.current = wrapper2;
    return wrapper2;
  };
  const wrapper = (0, import_react4.useMemo)(createWrapper, []);
  (0, import_react4.useEffect)(() => {
    const loader = type === "circle" ? new import_progressbar.Circle(wrapper, __spreadValues({
      strokeWidth: 6,
      easing: "easeInOut",
      duration: 1400,
      color: "#FFEA82",
      trailColor: "#eee",
      trailWidth: 1,
      svgStyle: null
    }, progressOptions)) : new import_progressbar.Line(wrapper, __spreadValues({
      strokeWidth: 4,
      easing: "easeInOut",
      duration: 1400,
      color: "#FFEA82",
      trailColor: "#eee",
      trailWidth: 1,
      svgStyle: { width: "100%", height: "100%" },
      text: {
        style: {
          color: "#999",
          position: "absolute",
          right: "0",
          top: "30px",
          padding: 0,
          margin: 0,
          transform: null
        },
        autoStyleContainer: false
      },
      from: { color: "#FFEA82" },
      to: { color: "#ED6A5A" },
      step: (state, bar) => {
        bar.setText(`${Math.round(bar.value() * 100)} %`);
      }
    }, progressOptions));
    loaderRef.current = loader;
    return () => {
      loader.destroy();
    };
  }, [wrapper, progressOptions, type]);
  (0, import_react4.useEffect)(() => {
    if (loaderRef.current) {
      loaderRef.current.animate(progress * 0.01);
    }
  }, [progress]);
  const node = (0, import_react4.useCallback)(
    (node2) => {
      if (node2) {
        node2.innerHTML = "";
        node2.appendChild(wrapper);
      }
    },
    [wrapper]
  );
  return /* @__PURE__ */ (0, import_jsx_runtime7.jsx)(
    "div",
    {
      className,
      ref: node,
      style: __spreadValues({ width: size, height: size }, style)
    }
  );
};
var Loader_default = Loader;

// src/ChatList/ChatList.tsx
var import_jsx_runtime8 = require("react/jsx-runtime");
var ChatList = (_a) => {
  var _b = _a, { dataSource } = _b, props = __objRest(_b, ["dataSource"]);
  var _a2;
  return /* @__PURE__ */ (0, import_jsx_runtime8.jsx)("div", { className: (0, import_classnames6.default)("rce-container-clist", props.className), children: (_a2 = dataSource == null ? void 0 : dataSource.map((el, index) => /* @__PURE__ */ (0, import_jsx_runtime8.jsx)(ChatItem_default, __spreadValues({}, el), `chat-item-${index.toString()}`))) != null ? _a2 : /* @__PURE__ */ (0, import_jsx_runtime8.jsx)(Loader_default, {}) });
};
var ChatList_default = ChatList;
