"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/MeetingMessage/MeetingMessage.tsx
var MeetingMessage_exports = {};
__export(MeetingMessage_exports, {
  default: () => MeetingMessage_default
});
module.exports = __toCommonJS(MeetingMessage_exports);
var import_react2 = require("react");
var import_fa = require("react-icons/fa");
var import_hi = require("react-icons/hi");
var import_io = require("react-icons/io");
var import_md = require("react-icons/md");
var import_date_fns = require("date-fns");

// src/Avatar/Avatar.tsx
var import_classnames = __toESM(require("classnames"));

// src/Avatar/LetterAvatar.tsx
var import_jsx_runtime = require("react/jsx-runtime");
var stringToColor = (str) => {
  let hash = 0;
  for (let i = 0; i < str.length; i++) {
    hash = str.charCodeAt(i) + ((hash << 5) - hash);
  }
  let colour = "#";
  for (let i = 0; i < 3; i++) {
    let value = hash >> i * 8 & 255;
    value = value % 150 + 50;
    colour += `00${value.toString(16)}`.substr(-2);
  }
  return colour;
};
function getAvatarLetters(letterItem, title) {
  let name = "U";
  if (letterItem == null ? void 0 : letterItem.letter) {
    name = letterItem.letter;
  }
  if (title) {
    name = title;
  }
  return name.toUpperCase().split(" ").map((w) => w[0]).slice(0, 2).join("");
}
var LetterAvatar = (props) => {
  var _a, _b, _c;
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    "div",
    {
      className: "rce-avatar rce-avatar-letter-background",
      style: {
        backgroundColor: stringToColor(
          (_c = (_b = (_a = props.letterItem) == null ? void 0 : _a.id) != null ? _b : props == null ? void 0 : props.title) != null ? _c : "unknown"
        )
      },
      children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
        "svg",
        {
          role: "img",
          xmlns: "http://www.w3.org/2000/svg",
          viewBox: "0 0 50 50",
          className: "rce-avatar-letter",
          children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
            "text",
            {
              fill: "white",
              fontSize: "25",
              x: "50%",
              y: "50%",
              dominantBaseline: "central",
              textAnchor: "middle",
              children: getAvatarLetters(props == null ? void 0 : props.letterItem, props == null ? void 0 : props.title)
            }
          )
        }
      )
    }
  );
};

// src/Avatar/Avatar.tsx
var import_jsx_runtime2 = require("react/jsx-runtime");
var Avatar = (_a) => {
  var _b = _a, {
    size = "default",
    rounded = true
  } = _b, props = __objRest(_b, [
    "size",
    "rounded"
  ]);
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(
    "div",
    {
      className: (0, import_classnames.default)(
        "rce-avatar-container",
        size,
        props == null ? void 0 : props.className,
        rounded && "rounded"
      ),
      style: props == null ? void 0 : props.style,
      children: [
        props.letterItem || !(props == null ? void 0 : props.src) ? /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(LetterAvatar, __spreadValues({}, props)) : /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
          "img",
          {
            loading: "lazy",
            alt: props == null ? void 0 : props.alt,
            src: props.src,
            className: "rce-avatar"
          }
        ),
        props == null ? void 0 : props.sideElement
      ]
    }
  );
};
var Avatar_default = Avatar;

// src/Dropdown/Dropdown.tsx
var import_react = require("react");
var import_classnames3 = __toESM(require("classnames"));

// src/Button/Button.tsx
var import_classnames2 = __toESM(require("classnames"));
var import_jsx_runtime3 = require("react/jsx-runtime");
var ButtonIcon = (props) => {
  var _a;
  return /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("span", { className: "rce-button-icon--container", children: /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(
    "span",
    {
      style: {
        float: (_a = props.float) != null ? _a : "inherit",
        fontSize: props.size || 12
      },
      className: "rce-button-icon",
      children: props.component
    }
  ) });
};
var Button = (_a) => {
  var _b = _a, {
    backgroundColor = "var(--rce-color-secondary)",
    color = "var(--rce-color-white)",
    style = {},
    borderWidth = 2,
    outlined,
    disabled,
    circle,
    squared,
    link,
    icon,
    buttonRef,
    text,
    className,
    children
  } = _b, rest = __objRest(_b, [
    "backgroundColor",
    "color",
    "style",
    "borderWidth",
    "outlined",
    "disabled",
    "circle",
    "squared",
    "link",
    "icon",
    "buttonRef",
    "text",
    "className",
    "children"
  ]);
  var _a2;
  return /* @__PURE__ */ (0, import_jsx_runtime3.jsxs)(
    "button",
    __spreadProps(__spreadValues({
      type: (_a2 = rest.type) != null ? _a2 : "button",
      ref: buttonRef,
      className: (0, import_classnames2.default)(
        "rce-button",
        className,
        outlined && "outlined",
        circle && "circle",
        link && "link",
        squared && "squared",
        disabled && "disabled"
      ),
      style: __spreadValues({
        backgroundColor: outlined ? color : backgroundColor,
        color: outlined ? backgroundColor : color,
        borderColor: backgroundColor,
        borderWidth,
        flexDirection: (icon == null ? void 0 : icon.float) === "left" ? "row-reverse" : "row"
      }, style)
    }, rest), {
      children: [
        children,
        text && /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("span", { children: text }),
        (icon == null ? void 0 : icon.component) && /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(ButtonIcon, __spreadValues({}, icon))
      ]
    })
  );
};
var Button_default = Button;

// src/Dropdown/Dropdown.tsx
var import_jsx_runtime4 = require("react/jsx-runtime");
var Dropdown = (_a) => {
  var _b = _a, {
    animationPosition = "northwest",
    animationType = "default",
    style = {}
  } = _b, props = __objRest(_b, [
    "animationPosition",
    "animationType",
    "style"
  ]);
  var _a2;
  const [show, setShow] = (0, import_react.useState)(false);
  const onBlur = () => {
    if (show) {
      console.log("blur");
      setShow(false);
    }
  };
  return /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)(
    "div",
    {
      className: (0, import_classnames3.default)("rce-dropdown-container", props.className),
      onBlur,
      children: [
        /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(Button_default, __spreadProps(__spreadValues({}, props.buttonProps), { onClick: (e) => setShow(!show) })),
        /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(
          "div",
          {
            className: (0, import_classnames3.default)(
              "rce-dropdown",
              animationType,
              `rce-dropdown-open__${animationPosition}`,
              { "dropdown-hide": !show },
              { "dropdown-show": show }
            ),
            style,
            children: /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)("ul", { children: [
              props.title && /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("span", { className: "rce-dropdown-title", children: props.title }),
              (_a2 = props.items) == null ? void 0 : _a2.map((x, i) => {
                var _a3;
                return /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(
                  "li",
                  {
                    onMouseDown: (e) => props.onSelect instanceof Function ? props.onSelect(e, i) : void 0,
                    children: typeof x !== "string" ? x.icon ? /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)("span", { className: "rce-button-icon--container", children: [
                      (x.icon.float === "right" || !x.icon.float) && /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(Button_default, __spreadValues({}, x)),
                      /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(
                        "span",
                        {
                          style: {
                            float: (_a3 = x.icon.float) != null ? _a3 : "inherit",
                            color: String(x.icon.color) || "inherit",
                            fontSize: Number(x.icon.size) || 12
                          },
                          className: (0, import_classnames3.default)(
                            "rce-button-icon",
                            x.icon.className
                          ),
                          children: x.icon.component
                        }
                      ),
                      x.icon.float === "left" && /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("button", { type: "button", className: "rce-button link", children: x.text })
                    ] }) : /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("button", { type: "button", className: "rce-button link", children: x.text }) : /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("button", { type: "button", className: "rce-button link", children: x })
                  },
                  i.toString()
                );
              })
            ] })
          }
        )
      ]
    }
  );
};
var Dropdown_default = Dropdown;

// src/MeetingMessage/MeetingMessage.tsx
var import_classnames4 = __toESM(require("classnames"));

// src/constants.ts
var DATE_FORMAT = "yyyy-MM-dd HH:mm:ss";

// src/MeetingMessage/MeetingMessage.tsx
var import_jsx_runtime5 = require("react/jsx-runtime");
var MeetingMessage = (props) => {
  var _a, _b;
  const [toggle, setToggle] = (0, import_react2.useState)(false);
  const PARTICIPANT_LIMIT = props.participantsLimit || Number.POSITIVE_INFINITY;
  const dateText = props.dateString ? props.dateString : props.date && (0, import_date_fns.format)(props.date, DATE_FORMAT);
  return /* @__PURE__ */ (0, import_jsx_runtime5.jsx)("div", { className: "rce-mbox-mtmg", children: /* @__PURE__ */ (0, import_jsx_runtime5.jsxs)("div", { className: "rce-mtmg", children: [
    /* @__PURE__ */ (0, import_jsx_runtime5.jsx)("div", { className: "rce-mtmg-subject", children: props.subject || "Unknown Meeting" }),
    /* @__PURE__ */ (0, import_jsx_runtime5.jsxs)("div", { className: "rce-mtmg-body", children: [
      /* @__PURE__ */ (0, import_jsx_runtime5.jsxs)("div", { className: "rce-mtmg-item", children: [
        /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(import_fa.FaCalendar, {}),
        /* @__PURE__ */ (0, import_jsx_runtime5.jsxs)("div", { className: "rce-mtmg-content", children: [
          /* @__PURE__ */ (0, import_jsx_runtime5.jsx)("span", { className: "rce-mtmg-title", children: props.title }),
          /* @__PURE__ */ (0, import_jsx_runtime5.jsx)("span", { className: "rce-mtmg-date", children: dateText })
        ] })
      ] }),
      props.onMeetingMoreSelect && props.moreItems && props.moreItems.length > 0 && /* @__PURE__ */ (0, import_jsx_runtime5.jsx)("div", { children: /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(
        Dropdown_default,
        {
          animationType: "bottom",
          animationPosition: "northeast",
          buttonProps: {
            className: "rce-mtmg-right-icon",
            icon: {
              component: /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(import_md.MdMoreHoriz, {}),
              size: 24
            }
          },
          items: props.moreItems,
          onSelect: (e) => {
            var _a2;
            return (_a2 = props.onMeetingMoreSelect) == null ? void 0 : _a2.call(props, e, props);
          }
        }
      ) })
    ] }),
    /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(
      Button_default,
      {
        className: "rce-mtmg-body-bottom",
        link: true,
        onClick: () => setToggle(!toggle),
        icon: {
          component: toggle ? /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(import_fa.FaCaretDown, {}) : /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(import_fa.FaCaretRight, {})
        },
        text: toggle ? /* @__PURE__ */ (0, import_jsx_runtime5.jsx)("div", { className: "rce-mtmg-bottom--tptitle", children: /* @__PURE__ */ (0, import_jsx_runtime5.jsx)("span", { children: props.collapseTitle }) }) : /* @__PURE__ */ (0, import_jsx_runtime5.jsx)("div", { className: "rce-mtmg-body-bottom--bttitle", children: /* @__PURE__ */ (0, import_jsx_runtime5.jsxs)("span", { children: [
          (_a = props.participants) == null ? void 0 : _a.slice(0, PARTICIPANT_LIMIT).map((x) => x.title || "Unknown").join(", "),
          props.participants && PARTICIPANT_LIMIT && props.participants.length > PARTICIPANT_LIMIT && `, +${props.participants.length - PARTICIPANT_LIMIT}`
        ] }) })
      }
    ),
    /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(
      "div",
      {
        className: (0, import_classnames4.default)("rce-mtmg-toogleContent", {
          "rce-mtmg-toogleContent--click": toggle
        }),
        children: (_b = props.dataSource) == null ? void 0 : _b.map((x, i) => {
          var _a2, _b2;
          return /* @__PURE__ */ (0, import_jsx_runtime5.jsxs)("div", { children: [
            !x.event && /* @__PURE__ */ (0, import_jsx_runtime5.jsxs)("div", { className: "rce-mitem", children: [
              /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(
                "div",
                {
                  className: (0, import_classnames4.default)("rce-mitem avatar", {
                    "rce-mitem no-avatar": !x.avatar
                  }),
                  children: x.avatar ? /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(Avatar_default, { title: x.title || "Unknown", src: x.avatar }) : /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(import_io.IoMdChatboxes, {})
                }
              ),
              /* @__PURE__ */ (0, import_jsx_runtime5.jsxs)("div", { className: "rce-mitem-body", children: [
                /* @__PURE__ */ (0, import_jsx_runtime5.jsxs)("div", { className: "rce-mitem-body--top", children: [
                  /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(
                    "div",
                    {
                      className: "rce-mitem-body--top-title",
                      onClick: (e) => {
                        var _a3;
                        return (_a3 = props.onMeetingLink) == null ? void 0 : _a3.call(props, e, props);
                      },
                      onKeyDown: console.log,
                      children: x.title
                    }
                  ),
                  /* @__PURE__ */ (0, import_jsx_runtime5.jsx)("div", { className: "rce-mitem-body--top-time", children: x.dateString ? x.dateString : x.date && x.date && (0, import_date_fns.format)(x.date, DATE_FORMAT) })
                ] }),
                /* @__PURE__ */ (0, import_jsx_runtime5.jsx)("div", { className: "rce-mitem-body--bottom", children: /* @__PURE__ */ (0, import_jsx_runtime5.jsx)("div", { className: "rce-mitem-body--bottom-title", children: x.message }) })
              ] })
            ] }),
            x.event && /* @__PURE__ */ (0, import_jsx_runtime5.jsx)("div", { className: "rce-mitem-event", children: /* @__PURE__ */ (0, import_jsx_runtime5.jsxs)("div", { className: "rce-mitem-bottom-body", children: [
              /* @__PURE__ */ (0, import_jsx_runtime5.jsxs)("div", { className: "rce-mitem-event-wrapper", children: [
                /* @__PURE__ */ (0, import_jsx_runtime5.jsx)("div", { className: "rce-mitem-body avatar", children: /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(import_hi.HiOutlineVideoCamera, {}) }),
                /* @__PURE__ */ (0, import_jsx_runtime5.jsxs)("div", { className: "rce-mitem-bottom-body-top", children: [
                  x.event.title,
                  /* @__PURE__ */ (0, import_jsx_runtime5.jsx)("div", { className: "rce-mitem-body--top-time", children: x.dateString ? x.dateString : x.date && (0, import_date_fns.format)(x.date, "yyyy-MM-dd HH:mm") }),
                  /* @__PURE__ */ (0, import_jsx_runtime5.jsx)("div", { className: "rce-mitem-avatar-content", children: /* @__PURE__ */ (0, import_jsx_runtime5.jsxs)("div", { className: "rce-mitem-avatar", children: [
                    (_b2 = x.event.avatars) == null ? void 0 : _b2.slice(0, PARTICIPANT_LIMIT).map((x2, i2) => /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(
                      Avatar_default,
                      {
                        title: x2.title,
                        src: x2.src,
                        size: "small"
                      },
                      i2.toString()
                    )),
                    x.event.avatars && x.event.avatarsLimit && x.event.avatars.length > x.event.avatarsLimit && /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(
                      "div",
                      {
                        className: "rce-mitem-length rce-mitem-tooltip",
                        tooltip: x.event.avatars.slice(
                          x.event.avatarsLimit,
                          x.event.avatars.length
                        ).map((avatar) => avatar.title).join(",").toString(),
                        children: /* @__PURE__ */ (0, import_jsx_runtime5.jsx)("span", { className: "rce-mitem-tooltip-text", children: `+${x.event.avatars.length - x.event.avatarsLimit}` })
                      }
                    )
                  ] }) })
                ] })
              ] }),
              x.record && /* @__PURE__ */ (0, import_jsx_runtime5.jsx)("div", { className: "rce-mtmg-call-record", children: /* @__PURE__ */ (0, import_jsx_runtime5.jsxs)("div", { className: "rce-mtmg-call-body", children: [
                /* @__PURE__ */ (0, import_jsx_runtime5.jsxs)(
                  "div",
                  {
                    onClick: (e) => {
                      var _a3;
                      return (_a3 = props.onMeetingVideoLink) == null ? void 0 : _a3.call(props, e, props);
                    },
                    onKeyDown: (e) => {
                      var _a3;
                      return (_a3 = props.onMeetingVideoLink) == null ? void 0 : _a3.call(props, e, props);
                    },
                    className: "rce-mtmg-call-avatars",
                    children: [
                      /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(
                        "img",
                        {
                          alt: "Meeting poster",
                          className: "rce-mtmg-call-avatars",
                          src: x.record.cover
                        }
                      ),
                      /* @__PURE__ */ (0, import_jsx_runtime5.jsx)("div", { className: "rce-mtmg-record-time", children: x.record.time })
                    ]
                  }
                ),
                /* @__PURE__ */ (0, import_jsx_runtime5.jsxs)("div", { className: "rce-mtmg-call-body-title", children: [
                  /* @__PURE__ */ (0, import_jsx_runtime5.jsx)("span", { children: x.record.title }),
                  /* @__PURE__ */ (0, import_jsx_runtime5.jsx)("div", { className: "rce-mtmg-call-body-bottom", children: x.record.savedBy })
                ] })
              ] }) })
            ] }) })
          ] }, (_a2 = x.id) != null ? _a2 : i.toString());
        })
      }
    )
  ] }) });
};
var MeetingMessage_default = MeetingMessage;
