"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/VideoMessage/VideoMessage.tsx
var VideoMessage_exports = {};
__export(VideoMessage_exports, {
  default: () => VideoMessage_default
});
module.exports = __toCommonJS(VideoMessage_exports);
var import_fa = require("react-icons/fa");
var import_classnames = __toESM(require("classnames"));

// src/Loader/Loader.tsx
var import_react = require("react");
var import_progressbar = require("progressbar.js");
var import_jsx_runtime = require("react/jsx-runtime");
var Loader = ({
  type = "circle",
  progressOptions = {
    strokeWidth: 6,
    easing: "easeInOut",
    duration: 1400,
    color: "#0791f1",
    trailColor: "#eee"
  },
  className,
  size = 100,
  progress = 0,
  style = {}
}) => {
  const wrapperRef = (0, import_react.useRef)(null);
  const loaderRef = (0, import_react.useRef)(null);
  const createWrapper = () => {
    const wrapper2 = document.createElement("div");
    wrapperRef.current = wrapper2;
    return wrapper2;
  };
  const wrapper = (0, import_react.useMemo)(createWrapper, []);
  (0, import_react.useEffect)(() => {
    const loader = type === "circle" ? new import_progressbar.Circle(wrapper, __spreadValues({
      strokeWidth: 6,
      easing: "easeInOut",
      duration: 1400,
      color: "#FFEA82",
      trailColor: "#eee",
      trailWidth: 1,
      svgStyle: null
    }, progressOptions)) : new import_progressbar.Line(wrapper, __spreadValues({
      strokeWidth: 4,
      easing: "easeInOut",
      duration: 1400,
      color: "#FFEA82",
      trailColor: "#eee",
      trailWidth: 1,
      svgStyle: { width: "100%", height: "100%" },
      text: {
        style: {
          color: "#999",
          position: "absolute",
          right: "0",
          top: "30px",
          padding: 0,
          margin: 0,
          transform: null
        },
        autoStyleContainer: false
      },
      from: { color: "#FFEA82" },
      to: { color: "#ED6A5A" },
      step: (state, bar) => {
        bar.setText(`${Math.round(bar.value() * 100)} %`);
      }
    }, progressOptions));
    loaderRef.current = loader;
    return () => {
      loader.destroy();
    };
  }, [wrapper, progressOptions, type]);
  (0, import_react.useEffect)(() => {
    if (loaderRef.current) {
      loaderRef.current.animate(progress * 0.01);
    }
  }, [progress]);
  const node = (0, import_react.useCallback)(
    (node2) => {
      if (node2) {
        node2.innerHTML = "";
        node2.appendChild(wrapper);
      }
    },
    [wrapper]
  );
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    "div",
    {
      className,
      ref: node,
      style: __spreadValues({ width: size, height: size }, style)
    }
  );
};
var Loader_default = Loader;

// src/VideoMessage/VideoMessage.tsx
var import_jsx_runtime2 = require("react/jsx-runtime");
var VideoMessage = (props) => {
  var _a, _b, _c, _d, _e, _f, _g, _h, _i;
  const progressOptions = {
    strokeWidth: 2.3,
    color: "#efe",
    trailColor: "#aaa",
    trailWidth: 1,
    step: (data, circle) => {
      var _a2, _b2;
      circle.path.setAttribute("trail", ((_a2 = data == null ? void 0 : data.state) == null ? void 0 : _a2.color) || "");
      circle.path.setAttribute("trailwidth-width", ((_b2 = data == null ? void 0 : data.state) == null ? void 0 : _b2.width) || "");
      const value = Math.round((circle == null ? void 0 : circle.value()) * 100);
      if (value === 0) circle == null ? void 0 : circle.setText("");
      else circle == null ? void 0 : circle.setText(value);
    }
  };
  const error = ((_a = props == null ? void 0 : props.data) == null ? void 0 : _a.status) && ((_b = props == null ? void 0 : props.data) == null ? void 0 : _b.status.error) === true;
  const downloaded = (_d = (_c = props == null ? void 0 : props.data) == null ? void 0 : _c.status) == null ? void 0 : _d.download;
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(
    "div",
    {
      className: (0, import_classnames.default)("rce-mbox-video", {
        "padding-time": !(props == null ? void 0 : props.text)
      }),
      children: [
        /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(
          "div",
          {
            className: "rce-mbox-video--video",
            style: __spreadValues({}, ((_e = props == null ? void 0 : props.data) == null ? void 0 : _e.width) && ((_f = props == null ? void 0 : props.data) == null ? void 0 : _f.height) && {
              width: props.data.width,
              height: props.data.height
            }),
            children: [
              !downloaded && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
                "img",
                {
                  src: (_g = props == null ? void 0 : props.data) == null ? void 0 : _g.uri,
                  alt: (_h = props == null ? void 0 : props.data) == null ? void 0 : _h.alt,
                  onClick: props.onOpen,
                  onKeyDown: console.log,
                  onLoad: props.onLoad,
                  onError: props.onPhotoError
                }
              ),
              downloaded && /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("video", { controls: true, controlsList: props.controlsList, children: [
                /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("source", { src: props == null ? void 0 : props.data.videoURL, type: "video/mp4" }),
                /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("track", { src: props == null ? void 0 : props.data.videoCaptionsURL, kind: "captions" }),
                "Your browser does not support HTML video."
              ] }),
              error && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className: "rce-mbox-video--video__block", children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("span", { className: "rce-mbox-video--video__block-item rce-mbox-video--error", children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_fa.FaExclamationTriangle, {}) }) }),
              !error && ((_i = props == null ? void 0 : props.data) == null ? void 0 : _i.status) && !downloaded && /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "rce-mbox-video--video__block", children: [
                !props.data.status.click && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
                  "button",
                  {
                    type: "button",
                    onClick: props.onDownload,
                    className: "rce-mbox-video--video__block-item rce-mbox-video--download",
                    children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_fa.FaCloudDownloadAlt, {})
                  }
                ),
                typeof props.data.status.loading === "number" && props.data.status.loading !== 0 && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
                  Loader_default,
                  {
                    animate: props.data.status.loading,
                    className: "rce-mbox-video--video__block-item",
                    progressOptions
                  }
                )
              ] })
            ]
          }
        ),
        (props == null ? void 0 : props.text) && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className: "rce-mbox-text", children: props.text })
      ]
    }
  );
};
var VideoMessage_default = VideoMessage;
