import {
  __spreadValues
} from "./chunk-YUVL7GHC.mjs";

// src/LocationMessage/Map.tsx
import { MapContainer, Marker, Popup, TileLayer } from "react-leaflet";
import "leaflet/dist/leaflet.css";
import L from "leaflet";
import { jsx, jsxs } from "react/jsx-runtime";
var markerIcon = L.icon({
  iconUrl: "https://unpkg.com/leaflet@1.9.3/dist/images/marker-icon.png",
  iconSize: [25, 41],
  iconAnchor: [12, 41],
  popupAnchor: [1, -34],
  shadowUrl: "https://unpkg.com/leaflet@1.9.3/dist/images/marker-shadow.png",
  shadowSize: [41, 41]
});
var CustomMarker = ({ position, children }) => {
  return /* @__PURE__ */ jsx(Marker, { position, icon: markerIcon, children });
};
var MapElement = (props) => {
  const { latitude, longitude, zoom } = props;
  function LocationMarker(props2) {
    if (!props2) {
      return null;
    }
    const { latLng, markerText, markerColor } = props2;
    return latLng ? /* @__PURE__ */ jsx(Marker, { position: latLng, icon: markerIcon, children: /* @__PURE__ */ jsx(Popup, { children: markerText }) }) : null;
  }
  return /* @__PURE__ */ jsxs(
    MapContainer,
    {
      center: [latitude, longitude],
      zoom,
      scrollWheelZoom: false,
      children: [
        /* @__PURE__ */ jsx(
          TileLayer,
          {
            attribution: '\xA9 <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors',
            url: "https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png"
          }
        ),
        props.marker && /* @__PURE__ */ jsx(LocationMarker, __spreadValues({}, props.marker))
      ]
    }
  );
};

export {
  markerIcon,
  CustomMarker,
  MapElement
};
