import {
  Loader_default
} from "./chunk-C7I5IR7I.mjs";
import {
  __spreadValues
} from "./chunk-YUVL7GHC.mjs";

// src/VideoMessage/VideoMessage.tsx
import { FaCloudDownloadAlt, FaExclamationTriangle } from "react-icons/fa";
import classNames from "classnames";
import { jsx, jsxs } from "react/jsx-runtime";
var VideoMessage = (props) => {
  var _a, _b, _c, _d, _e, _f, _g, _h, _i;
  const progressOptions = {
    strokeWidth: 2.3,
    color: "#efe",
    trailColor: "#aaa",
    trailWidth: 1,
    step: (data, circle) => {
      var _a2, _b2;
      circle.path.setAttribute("trail", ((_a2 = data == null ? void 0 : data.state) == null ? void 0 : _a2.color) || "");
      circle.path.setAttribute("trailwidth-width", ((_b2 = data == null ? void 0 : data.state) == null ? void 0 : _b2.width) || "");
      const value = Math.round((circle == null ? void 0 : circle.value()) * 100);
      if (value === 0) circle == null ? void 0 : circle.setText("");
      else circle == null ? void 0 : circle.setText(value);
    }
  };
  const error = ((_a = props == null ? void 0 : props.data) == null ? void 0 : _a.status) && ((_b = props == null ? void 0 : props.data) == null ? void 0 : _b.status.error) === true;
  const downloaded = (_d = (_c = props == null ? void 0 : props.data) == null ? void 0 : _c.status) == null ? void 0 : _d.download;
  return /* @__PURE__ */ jsxs(
    "div",
    {
      className: classNames("rce-mbox-video", {
        "padding-time": !(props == null ? void 0 : props.text)
      }),
      children: [
        /* @__PURE__ */ jsxs(
          "div",
          {
            className: "rce-mbox-video--video",
            style: __spreadValues({}, ((_e = props == null ? void 0 : props.data) == null ? void 0 : _e.width) && ((_f = props == null ? void 0 : props.data) == null ? void 0 : _f.height) && {
              width: props.data.width,
              height: props.data.height
            }),
            children: [
              !downloaded && /* @__PURE__ */ jsx(
                "img",
                {
                  src: (_g = props == null ? void 0 : props.data) == null ? void 0 : _g.uri,
                  alt: (_h = props == null ? void 0 : props.data) == null ? void 0 : _h.alt,
                  onClick: props.onOpen,
                  onKeyDown: console.log,
                  onLoad: props.onLoad,
                  onError: props.onPhotoError
                }
              ),
              downloaded && /* @__PURE__ */ jsxs("video", { controls: true, controlsList: props.controlsList, children: [
                /* @__PURE__ */ jsx("source", { src: props == null ? void 0 : props.data.videoURL, type: "video/mp4" }),
                /* @__PURE__ */ jsx("track", { src: props == null ? void 0 : props.data.videoCaptionsURL, kind: "captions" }),
                "Your browser does not support HTML video."
              ] }),
              error && /* @__PURE__ */ jsx("div", { className: "rce-mbox-video--video__block", children: /* @__PURE__ */ jsx("span", { className: "rce-mbox-video--video__block-item rce-mbox-video--error", children: /* @__PURE__ */ jsx(FaExclamationTriangle, {}) }) }),
              !error && ((_i = props == null ? void 0 : props.data) == null ? void 0 : _i.status) && !downloaded && /* @__PURE__ */ jsxs("div", { className: "rce-mbox-video--video__block", children: [
                !props.data.status.click && /* @__PURE__ */ jsx(
                  "button",
                  {
                    type: "button",
                    onClick: props.onDownload,
                    className: "rce-mbox-video--video__block-item rce-mbox-video--download",
                    children: /* @__PURE__ */ jsx(FaCloudDownloadAlt, {})
                  }
                ),
                typeof props.data.status.loading === "number" && props.data.status.loading !== 0 && /* @__PURE__ */ jsx(
                  Loader_default,
                  {
                    animate: props.data.status.loading,
                    className: "rce-mbox-video--video__block-item",
                    progressOptions
                  }
                )
              ] })
            ]
          }
        ),
        (props == null ? void 0 : props.text) && /* @__PURE__ */ jsx("div", { className: "rce-mbox-text", children: props.text })
      ]
    }
  );
};
var VideoMessage_default = VideoMessage;

export {
  VideoMessage_default
};
