import {
  __spreadValues
} from "./chunk-YUVL7GHC.mjs";

// src/Loader/Loader.tsx
import { useCallback, useEffect, useMemo, useRef } from "react";
import { Circle, Line } from "progressbar.js";
import { jsx } from "react/jsx-runtime";
var Loader = ({
  type = "circle",
  progressOptions = {
    strokeWidth: 6,
    easing: "easeInOut",
    duration: 1400,
    color: "#0791f1",
    trailColor: "#eee"
  },
  className,
  size = 100,
  progress = 0,
  style = {}
}) => {
  const wrapperRef = useRef(null);
  const loaderRef = useRef(null);
  const createWrapper = () => {
    const wrapper2 = document.createElement("div");
    wrapperRef.current = wrapper2;
    return wrapper2;
  };
  const wrapper = useMemo(createWrapper, []);
  useEffect(() => {
    const loader = type === "circle" ? new Circle(wrapper, __spreadValues({
      strokeWidth: 6,
      easing: "easeInOut",
      duration: 1400,
      color: "#FFEA82",
      trailColor: "#eee",
      trailWidth: 1,
      svgStyle: null
    }, progressOptions)) : new Line(wrapper, __spreadValues({
      strokeWidth: 4,
      easing: "easeInOut",
      duration: 1400,
      color: "#FFEA82",
      trailColor: "#eee",
      trailWidth: 1,
      svgStyle: { width: "100%", height: "100%" },
      text: {
        style: {
          color: "#999",
          position: "absolute",
          right: "0",
          top: "30px",
          padding: 0,
          margin: 0,
          transform: null
        },
        autoStyleContainer: false
      },
      from: { color: "#FFEA82" },
      to: { color: "#ED6A5A" },
      step: (state, bar) => {
        bar.setText(`${Math.round(bar.value() * 100)} %`);
      }
    }, progressOptions));
    loaderRef.current = loader;
    return () => {
      loader.destroy();
    };
  }, [wrapper, progressOptions, type]);
  useEffect(() => {
    if (loaderRef.current) {
      loaderRef.current.animate(progress * 0.01);
    }
  }, [progress]);
  const node = useCallback(
    (node2) => {
      if (node2) {
        node2.innerHTML = "";
        node2.appendChild(wrapper);
      }
    },
    [wrapper]
  );
  return /* @__PURE__ */ jsx(
    "div",
    {
      className,
      ref: node,
      style: __spreadValues({ width: size, height: size }, style)
    }
  );
};
var Loader_default = Loader;

export {
  Loader_default
};
