import {
  Dropdown_default
} from "./chunk-45MLN22O.mjs";
import {
  Button_default
} from "./chunk-63HD37UK.mjs";
import {
  DATE_FORMAT
} from "./chunk-VZ4NQKVS.mjs";
import {
  Avatar_default
} from "./chunk-KTYBYP2L.mjs";

// src/MeetingMessage/MeetingMessage.tsx
import { useState } from "react";
import { FaCalendar, FaCaretDown, FaCaretRight } from "react-icons/fa";
import { HiOutlineVideoCamera } from "react-icons/hi";
import { IoMdChatboxes } from "react-icons/io";
import { MdMoreHoriz } from "react-icons/md";
import { format } from "date-fns";
import classNames from "classnames";
import { jsx, jsxs } from "react/jsx-runtime";
var MeetingMessage = (props) => {
  var _a, _b;
  const [toggle, setToggle] = useState(false);
  const PARTICIPANT_LIMIT = props.participantsLimit || Number.POSITIVE_INFINITY;
  const dateText = props.dateString ? props.dateString : props.date && format(props.date, DATE_FORMAT);
  return /* @__PURE__ */ jsx("div", { className: "rce-mbox-mtmg", children: /* @__PURE__ */ jsxs("div", { className: "rce-mtmg", children: [
    /* @__PURE__ */ jsx("div", { className: "rce-mtmg-subject", children: props.subject || "Unknown Meeting" }),
    /* @__PURE__ */ jsxs("div", { className: "rce-mtmg-body", children: [
      /* @__PURE__ */ jsxs("div", { className: "rce-mtmg-item", children: [
        /* @__PURE__ */ jsx(FaCalendar, {}),
        /* @__PURE__ */ jsxs("div", { className: "rce-mtmg-content", children: [
          /* @__PURE__ */ jsx("span", { className: "rce-mtmg-title", children: props.title }),
          /* @__PURE__ */ jsx("span", { className: "rce-mtmg-date", children: dateText })
        ] })
      ] }),
      props.onMeetingMoreSelect && props.moreItems && props.moreItems.length > 0 && /* @__PURE__ */ jsx("div", { children: /* @__PURE__ */ jsx(
        Dropdown_default,
        {
          animationType: "bottom",
          animationPosition: "northeast",
          buttonProps: {
            className: "rce-mtmg-right-icon",
            icon: {
              component: /* @__PURE__ */ jsx(MdMoreHoriz, {}),
              size: 24
            }
          },
          items: props.moreItems,
          onSelect: (e) => {
            var _a2;
            return (_a2 = props.onMeetingMoreSelect) == null ? void 0 : _a2.call(props, e, props);
          }
        }
      ) })
    ] }),
    /* @__PURE__ */ jsx(
      Button_default,
      {
        className: "rce-mtmg-body-bottom",
        link: true,
        onClick: () => setToggle(!toggle),
        icon: {
          component: toggle ? /* @__PURE__ */ jsx(FaCaretDown, {}) : /* @__PURE__ */ jsx(FaCaretRight, {})
        },
        text: toggle ? /* @__PURE__ */ jsx("div", { className: "rce-mtmg-bottom--tptitle", children: /* @__PURE__ */ jsx("span", { children: props.collapseTitle }) }) : /* @__PURE__ */ jsx("div", { className: "rce-mtmg-body-bottom--bttitle", children: /* @__PURE__ */ jsxs("span", { children: [
          (_a = props.participants) == null ? void 0 : _a.slice(0, PARTICIPANT_LIMIT).map((x) => x.title || "Unknown").join(", "),
          props.participants && PARTICIPANT_LIMIT && props.participants.length > PARTICIPANT_LIMIT && `, +${props.participants.length - PARTICIPANT_LIMIT}`
        ] }) })
      }
    ),
    /* @__PURE__ */ jsx(
      "div",
      {
        className: classNames("rce-mtmg-toogleContent", {
          "rce-mtmg-toogleContent--click": toggle
        }),
        children: (_b = props.dataSource) == null ? void 0 : _b.map((x, i) => {
          var _a2, _b2;
          return /* @__PURE__ */ jsxs("div", { children: [
            !x.event && /* @__PURE__ */ jsxs("div", { className: "rce-mitem", children: [
              /* @__PURE__ */ jsx(
                "div",
                {
                  className: classNames("rce-mitem avatar", {
                    "rce-mitem no-avatar": !x.avatar
                  }),
                  children: x.avatar ? /* @__PURE__ */ jsx(Avatar_default, { title: x.title || "Unknown", src: x.avatar }) : /* @__PURE__ */ jsx(IoMdChatboxes, {})
                }
              ),
              /* @__PURE__ */ jsxs("div", { className: "rce-mitem-body", children: [
                /* @__PURE__ */ jsxs("div", { className: "rce-mitem-body--top", children: [
                  /* @__PURE__ */ jsx(
                    "div",
                    {
                      className: "rce-mitem-body--top-title",
                      onClick: (e) => {
                        var _a3;
                        return (_a3 = props.onMeetingLink) == null ? void 0 : _a3.call(props, e, props);
                      },
                      onKeyDown: console.log,
                      children: x.title
                    }
                  ),
                  /* @__PURE__ */ jsx("div", { className: "rce-mitem-body--top-time", children: x.dateString ? x.dateString : x.date && x.date && format(x.date, DATE_FORMAT) })
                ] }),
                /* @__PURE__ */ jsx("div", { className: "rce-mitem-body--bottom", children: /* @__PURE__ */ jsx("div", { className: "rce-mitem-body--bottom-title", children: x.message }) })
              ] })
            ] }),
            x.event && /* @__PURE__ */ jsx("div", { className: "rce-mitem-event", children: /* @__PURE__ */ jsxs("div", { className: "rce-mitem-bottom-body", children: [
              /* @__PURE__ */ jsxs("div", { className: "rce-mitem-event-wrapper", children: [
                /* @__PURE__ */ jsx("div", { className: "rce-mitem-body avatar", children: /* @__PURE__ */ jsx(HiOutlineVideoCamera, {}) }),
                /* @__PURE__ */ jsxs("div", { className: "rce-mitem-bottom-body-top", children: [
                  x.event.title,
                  /* @__PURE__ */ jsx("div", { className: "rce-mitem-body--top-time", children: x.dateString ? x.dateString : x.date && format(x.date, "yyyy-MM-dd HH:mm") }),
                  /* @__PURE__ */ jsx("div", { className: "rce-mitem-avatar-content", children: /* @__PURE__ */ jsxs("div", { className: "rce-mitem-avatar", children: [
                    (_b2 = x.event.avatars) == null ? void 0 : _b2.slice(0, PARTICIPANT_LIMIT).map((x2, i2) => /* @__PURE__ */ jsx(
                      Avatar_default,
                      {
                        title: x2.title,
                        src: x2.src,
                        size: "small"
                      },
                      i2.toString()
                    )),
                    x.event.avatars && x.event.avatarsLimit && x.event.avatars.length > x.event.avatarsLimit && /* @__PURE__ */ jsx(
                      "div",
                      {
                        className: "rce-mitem-length rce-mitem-tooltip",
                        tooltip: x.event.avatars.slice(
                          x.event.avatarsLimit,
                          x.event.avatars.length
                        ).map((avatar) => avatar.title).join(",").toString(),
                        children: /* @__PURE__ */ jsx("span", { className: "rce-mitem-tooltip-text", children: `+${x.event.avatars.length - x.event.avatarsLimit}` })
                      }
                    )
                  ] }) })
                ] })
              ] }),
              x.record && /* @__PURE__ */ jsx("div", { className: "rce-mtmg-call-record", children: /* @__PURE__ */ jsxs("div", { className: "rce-mtmg-call-body", children: [
                /* @__PURE__ */ jsxs(
                  "div",
                  {
                    onClick: (e) => {
                      var _a3;
                      return (_a3 = props.onMeetingVideoLink) == null ? void 0 : _a3.call(props, e, props);
                    },
                    onKeyDown: (e) => {
                      var _a3;
                      return (_a3 = props.onMeetingVideoLink) == null ? void 0 : _a3.call(props, e, props);
                    },
                    className: "rce-mtmg-call-avatars",
                    children: [
                      /* @__PURE__ */ jsx(
                        "img",
                        {
                          alt: "Meeting poster",
                          className: "rce-mtmg-call-avatars",
                          src: x.record.cover
                        }
                      ),
                      /* @__PURE__ */ jsx("div", { className: "rce-mtmg-record-time", children: x.record.time })
                    ]
                  }
                ),
                /* @__PURE__ */ jsxs("div", { className: "rce-mtmg-call-body-title", children: [
                  /* @__PURE__ */ jsx("span", { children: x.record.title }),
                  /* @__PURE__ */ jsx("div", { className: "rce-mtmg-call-body-bottom", children: x.record.savedBy })
                ] })
              ] }) })
            ] }) })
          ] }, (_a2 = x.id) != null ? _a2 : i.toString());
        })
      }
    )
  ] }) });
};
var MeetingMessage_default = MeetingMessage;

export {
  MeetingMessage_default
};
