import {
  SystemMessage_default
} from "./chunk-A73P7STW.mjs";
import {
  VideoMessage_default
} from "./chunk-A4BIL7XO.mjs";
import {
  LeftNotch
} from "./chunk-PUN464RA.mjs";
import {
  RightNotch
} from "./chunk-BMQ5JV2I.mjs";
import {
  MessageStatus
} from "./chunk-W236M2BT.mjs";
import {
  Reactions
} from "./chunk-R2M35HDE.mjs";
import {
  PhotoMessage_default
} from "./chunk-SLZWSA5J.mjs";
import {
  ReplyMessage_default
} from "./chunk-6MSRT2AT.mjs";
import {
  LocationMessage_default
} from "./chunk-ASCZ3WY2.mjs";
import {
  MeetingLink_default
} from "./chunk-Z64FDAHP.mjs";
import {
  MeetingMessage_default
} from "./chunk-CERBDIRL.mjs";
import {
  relativeDateFormat
} from "./chunk-Y27BAB3M.mjs";
import {
  FileMessage_default
} from "./chunk-RJTUV4QC.mjs";
import {
  Button_default
} from "./chunk-63HD37UK.mjs";
import {
  AudioMessage_default
} from "./chunk-A6WEVOZG.mjs";
import {
  Avatar_default
} from "./chunk-KTYBYP2L.mjs";
import {
  __spreadProps,
  __spreadValues
} from "./chunk-YUVL7GHC.mjs";

// src/MessageBox/MessageBox.tsx
import { useEffect, useRef } from "react";
import classNames from "classnames";
import {
  MdDelete,
  MdEdit,
  MdOutlineEmojiEmotions,
  MdReply,
  MdReplyAll
} from "react-icons/md";
import { format } from "date-fns";
import { jsx, jsxs } from "react/jsx-runtime";
var MessageBox = (props) => {
  const prevProps = useRef(props.focus);
  const messageRef = useRef(null);
  const positionCls = classNames(
    "rce-mbox",
    `rce-mbox-${props.position === "right" ? "right" : "left"}`
  );
  const defaultActionStyle = {
    color: "var(--rce-color-white)",
    backgroundColor: "rgba(110, 110, 120, .5)",
    style: {
      padding: "6px",
      borderWidth: 0
    }
  };
  const thatAbsoluteTime = !/(text|video|file|meeting|audio)/g.test(props.type || "text") && !(props.type === "location" && props.text);
  const dateText = props.date && (props.dateString || format(props.date, "HH:mm"));
  useEffect(() => {
    var _a;
    if (prevProps.current !== props.focus && props.focus) {
      if (messageRef == null ? void 0 : messageRef.current) {
        (_a = messageRef.current) == null ? void 0 : _a.scrollIntoView({
          behavior: "smooth",
          block: "nearest",
          inline: "start"
        });
        if (props == null ? void 0 : props.onMessageFocused) props.onMessageFocused(true);
      }
    }
    prevProps.current = props.focus;
  }, [props.focus, props.onMessageFocused]);
  return /* @__PURE__ */ jsxs(
    "div",
    {
      ref: messageRef,
      className: classNames("rce-container-mbox", props.className),
      children: [
        props == null ? void 0 : props.renderAddCmp,
        props.type === "system" ? /* @__PURE__ */ jsx(SystemMessage_default, __spreadValues({}, props)) : /* @__PURE__ */ jsxs(
          "div",
          {
            className: classNames(
              positionCls,
              { "rce-mbox--clear-padding": thatAbsoluteTime },
              { "rce-mbox--clear-notch": !!(props == null ? void 0 : props.notch) }
            ),
            children: [
              (props == null ? void 0 : props.notch) !== false && (props.position === "right" ? /* @__PURE__ */ jsx(
                RightNotch,
                {
                  style: __spreadValues({
                    fill: "var(--rce-mbox-background-right)"
                  }, props.notchStyle),
                  focus: props.focus
                }
              ) : /* @__PURE__ */ jsx(
                LeftNotch,
                {
                  style: __spreadValues({
                    fill: "var(--rce-mbox-background)"
                  }, props.notchStyle),
                  focus: props.focus
                }
              )),
              /* @__PURE__ */ jsxs(
                "div",
                {
                  className: classNames("rce-mbox-body", {
                    "message-focus": props.focus
                  }),
                  onContextMenu: props == null ? void 0 : props.onContextMenu,
                  style: props.style,
                  children: [
                    /* @__PURE__ */ jsxs("div", { className: "rce-mbox-action-buttons", children: [
                      !props.retracted && props.EmojiButton === true && /* @__PURE__ */ jsx(
                        Button_default,
                        __spreadValues({
                          circle: true,
                          className: classNames(
                            "rce-mbox-action",
                            "rce-mbox-emoji-button",
                            {
                              "rce-mbox-forward-right": props.position === "left"
                            },
                            {
                              "rce-mbox-forward-left": props.position === "right"
                            }
                          ),
                          onClick: (e) => {
                            var _a;
                            return (_a = props == null ? void 0 : props.AddEmoji) == null ? void 0 : _a.call(props, e, props);
                          },
                          icon: {
                            component: /* @__PURE__ */ jsx(MdOutlineEmojiEmotions, { size: 20 })
                          }
                        }, defaultActionStyle)
                      ),
                      !props.retracted && !props.forwarded && /* @__PURE__ */ jsx(
                        Button_default,
                        __spreadValues({
                          circle: true,
                          className: classNames(
                            "rce-mbox-action",
                            "rce-mbox-forward",
                            `rce-mbox-forward-${props.position === "right" ? "right" : "left"}`
                          ),
                          onClick: (e) => {
                            var _a;
                            return (_a = props.onForward) == null ? void 0 : _a.call(props, e, props);
                          },
                          icon: {
                            component: /* @__PURE__ */ jsx(
                              MdReplyAll,
                              {
                                size: 20,
                                className: "reverse-icon-horizontal"
                              }
                            )
                          }
                        }, defaultActionStyle)
                      ),
                      !props.retracted && props.replyButton && /* @__PURE__ */ jsx(
                        Button_default,
                        __spreadValues({
                          circle: true,
                          className: !props.forwarded ? classNames(
                            "rce-mbox-action",
                            "rce-mbox-forward",
                            `rce-mbox-forward-${props.position}`
                          ) : classNames(
                            "rce-mbox-action",
                            "rce-mbox-forward",
                            `rce-mbox-reply-btn-${props.position}`
                          ),
                          onClick: (ev) => {
                            var _a;
                            return (_a = props.onReplyMessage) == null ? void 0 : _a.call(props, ev, props);
                          },
                          icon: {
                            component: /* @__PURE__ */ jsx(
                              MdReply,
                              {
                                size: 20,
                                className: "reverse-icon-horizontal"
                              }
                            )
                          }
                        }, defaultActionStyle)
                      ),
                      !props.retracted && props.removeButton && /* @__PURE__ */ jsx(
                        Button_default,
                        __spreadValues({
                          circle: true,
                          className: props.forwarded ? classNames(
                            "rce-mbox-action",
                            "rce-mbox-remove",
                            `rce-mbox-remove-${props.position}`
                          ) : classNames(
                            "rce-mbox-action",
                            "rce-mbox-forward",
                            `rce-mbox-reply-btn-${props.position}`
                          ),
                          onClick: (ev) => {
                            var _a;
                            return (_a = props.onRemoveMessage) == null ? void 0 : _a.call(props, ev, props);
                          },
                          icon: {
                            component: /* @__PURE__ */ jsx(MdDelete, { size: 20 })
                          }
                        }, defaultActionStyle)
                      )
                    ] }),
                    (props.title || props.avatar) && /* @__PURE__ */ jsxs(
                      Button_default,
                      {
                        link: true,
                        style: __spreadValues({}, props.titleColor && {
                          color: props.titleColor
                        }),
                        onClick: (event) => {
                          var _a;
                          return (_a = props.onTitleClick) == null ? void 0 : _a.call(props, event, props);
                        },
                        className: classNames("rce-mbox-title", {
                          "rce-mbox-title--clear": props.type === "text"
                        }),
                        children: [
                          props.avatar && props.title && /* @__PURE__ */ jsx(
                            Avatar_default,
                            {
                              title: props.title,
                              size: "xsmall",
                              letterItem: props.letterItem,
                              src: props.avatar
                            }
                          ),
                          props.title && /* @__PURE__ */ jsx("span", { children: props.title })
                        ]
                      }
                    ),
                    props.reply ? /* @__PURE__ */ jsx(
                      ReplyMessage_default,
                      __spreadValues({
                        onClick: (e) => {
                          var _a;
                          return (_a = props.onReplyMessage) == null ? void 0 : _a.call(props, e, props);
                        }
                      }, props.reply)
                    ) : null,
                    props.forwarded ? /* @__PURE__ */ jsx("div", { className: "rce-mbox-forwarded-message", children: /* @__PURE__ */ jsxs("div", { className: "rce-mbox-forwarded-message-inner", children: [
                      /* @__PURE__ */ jsx(
                        MdReply,
                        {
                          size: 15,
                          style: { padding: 0 },
                          className: "reverse-icon-horizontal"
                        }
                      ),
                      (props == null ? void 0 : props.forwardedMessageText) && /* @__PURE__ */ jsx("i", { children: props.forwardedMessageText })
                    ] }) }) : null,
                    props.type === "text" && /* @__PURE__ */ jsxs(
                      "div",
                      {
                        className: classNames(
                          "rce-mbox-text",
                          (props == null ? void 0 : props.position) === "right" ? "right" : "left",
                          {
                            "rce-mbox-text-retracted": props.retracted
                          }
                        ),
                        children: [
                          !props.forwarded && props.retracted && /* @__PURE__ */ jsx(MdEdit, {}),
                          props.text
                        ]
                      }
                    ),
                    props.type === "location" && /* @__PURE__ */ jsx(LocationMessage_default, __spreadValues({}, props)),
                    props.type === "photo" && /* @__PURE__ */ jsx(PhotoMessage_default, __spreadValues({}, props)),
                    props.type === "video" && /* @__PURE__ */ jsx(VideoMessage_default, __spreadValues({}, props)),
                    props.type === "file" && /* @__PURE__ */ jsx(FileMessage_default, __spreadValues({}, props)),
                    props.type === "meeting" && /* @__PURE__ */ jsx(MeetingMessage_default, __spreadValues({}, props)),
                    props.type === "audio" && /* @__PURE__ */ jsx(AudioMessage_default, __spreadValues({}, props)),
                    props.type === "meetingLink" && (props == null ? void 0 : props.actionButtons) && /* @__PURE__ */ jsx(
                      MeetingLink_default,
                      __spreadProps(__spreadValues({}, props), {
                        text: (props == null ? void 0 : props.meetingLinkText) || "Join Meeting",
                        actionButtons: props.actionButtons,
                        meetingID: props.meetingID
                      })
                    ),
                    /* @__PURE__ */ jsxs(
                      "div",
                      {
                        title: props.statusTitle,
                        className: classNames(
                          "rce-mbox-time",
                          { "rce-mbox-time-block": thatAbsoluteTime },
                          { "non-copiable": !props.copiableDate }
                        ),
                        "data-text": props.copiableDate ? void 0 : dateText,
                        children: [
                          props.copiableDate && props.date !== void 0 && relativeDateFormat(props.date),
                          (props == null ? void 0 : props.status) && /* @__PURE__ */ jsx(MessageStatus, { status: props.status })
                        ]
                      }
                    ),
                    (props == null ? void 0 : props.reactions) && /* @__PURE__ */ jsx(Reactions, { reactions: props.reactions })
                  ]
                }
              )
            ]
          }
        )
      ]
    }
  );
};
var MessageBox_default = MessageBox;

export {
  MessageBox_default
};
