import {
  Loader_default
} from "./chunk-C7I5IR7I.mjs";
import {
  __pow
} from "./chunk-YUVL7GHC.mjs";

// src/FileMessage/FileMessage.tsx
import {
  FaCloudDownloadAlt,
  FaExclamationTriangle,
  FaFile
} from "react-icons/fa";
import classNames from "classnames";
import { jsx, jsxs } from "react/jsx-runtime";
function formatFileSize(size) {
  if (typeof size === "string") {
    return size;
  }
  if (typeof size === "number") {
    return humanFileSize(size);
  }
  return "Unknown File Size";
}
function humanFileSize(bytes, decimals = 2) {
  if (bytes === 0) return "0 Bytes";
  const k = 1024;
  const dm = decimals || 2;
  const sizes = ["Bytes", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB"];
  const i = Math.floor(Math.log(bytes) / Math.log(k));
  return `${Number.parseFloat((bytes / __pow(k, i)).toFixed(dm))} ${sizes[i]}`;
}
var FileMessage = (props) => {
  var _a, _b, _c, _d, _e, _f, _g, _h, _i, _j, _k, _l, _m;
  const progressOptions = {
    strokeWidth: 6,
    easing: "easeInOut",
    duration: 1400,
    color: "var(--rce-color-primary)",
    trailColor: "var(--rce-color-gray-100)"
  };
  const error = ((_a = props == null ? void 0 : props.data) == null ? void 0 : _a.status) && ((_b = props == null ? void 0 : props.data) == null ? void 0 : _b.status.error) === true;
  const onClick = (e) => {
    var _a2, _b2, _c2;
    if (!((_a2 = props == null ? void 0 : props.data) == null ? void 0 : _a2.status)) return;
    if (!((_b2 = props == null ? void 0 : props.data) == null ? void 0 : _b2.status.download) && props.onDownload instanceof Function)
      props.onDownload(e);
    else if (((_c2 = props == null ? void 0 : props.data) == null ? void 0 : _c2.status.download) && props.onOpen instanceof Function)
      props.onOpen(e);
  };
  const filesize = formatFileSize((_c = props == null ? void 0 : props.data) == null ? void 0 : _c.size);
  return /* @__PURE__ */ jsx("div", { className: "rce-mbox-file", children: /* @__PURE__ */ jsxs("button", { type: "button", onClick, children: [
    /* @__PURE__ */ jsxs(
      "div",
      {
        className: classNames(
          "rce-mbox-file--icon",
          `rce-mbox-file-extension-${(_d = props == null ? void 0 : props.data) == null ? void 0 : _d.extension}`
        ),
        children: [
          /* @__PURE__ */ jsx(FaFile, { color: "#aaa" }),
          ((_e = props == null ? void 0 : props.data) == null ? void 0 : _e.size) ? /* @__PURE__ */ jsx("div", { className: "rce-mbox-file--size", children: filesize }) : null
        ]
      }
    ),
    /* @__PURE__ */ jsx("div", { className: "rce-mbox-file--text", children: (_f = props.data) == null ? void 0 : _f.name }),
    /* @__PURE__ */ jsxs("div", { className: "rce-mbox-file--buttons", children: [
      error && /* @__PURE__ */ jsx("span", { className: "rce-error-button", children: /* @__PURE__ */ jsx(FaExclamationTriangle, { color: "#ff3d3d" }) }),
      !error && ((_g = props == null ? void 0 : props.data) == null ? void 0 : _g.status) && !((_h = props == null ? void 0 : props.data) == null ? void 0 : _h.status.download) && !((_i = props == null ? void 0 : props.data) == null ? void 0 : _i.status.click) && /* @__PURE__ */ jsx(FaCloudDownloadAlt, { color: "#aaa" }),
      !error && ((_j = props == null ? void 0 : props.data) == null ? void 0 : _j.status) && typeof ((_k = props == null ? void 0 : props.data) == null ? void 0 : _k.status.loading) === "number" && ((_l = props == null ? void 0 : props.data) == null ? void 0 : _l.status.loading) > 0 && /* @__PURE__ */ jsx(
        Loader_default,
        {
          animate: !!((_m = props == null ? void 0 : props.data) == null ? void 0 : _m.status.loading),
          className: "rce-mbox-file--loading",
          progressOptions
        }
      )
    ] })
  ] }) });
};
var FileMessage_default = FileMessage;

export {
  FileMessage_default
};
