import {
  Avatar_default
} from "./chunk-KTYBYP2L.mjs";
import {
  __spreadValues
} from "./chunk-YUVL7GHC.mjs";

// src/MeetingItem/MeetingItem.tsx
import { MdCall, MdLink, MdVideoCall } from "react-icons/md";
import { formatDistance } from "date-fns";
import classNames from "classnames";
import { useState } from "react";
import { jsx, jsxs } from "react/jsx-runtime";
var relativeDateFormat = (date = /* @__PURE__ */ new Date()) => {
  let dateObject;
  try {
    if (date instanceof Date) {
      dateObject = date;
    } else {
      dateObject = new Date(date);
    }
  } catch (error) {
    dateObject = /* @__PURE__ */ new Date();
    console.error("the date provided is not valid", error);
  }
  return formatDistance(dateObject, /* @__PURE__ */ new Date(), {
    addSuffix: true
  }).replace("less than a minute ago", "now");
};
var MeetingItem = (props) => {
  var _a, _b;
  const [attributes, setAttributes] = useState(__spreadValues({
    subjectLimit: 60,
    avatarFlexible: false,
    date: /* @__PURE__ */ new Date(),
    avatarLimit: 5,
    avatars: [],
    audioMuted: true,
    dateString: (_a = props.dateString) != null ? _a : relativeDateFormat(props.date)
  }, props));
  const subject = attributes.subject && attributes.subjectLimit && attributes.subject.substring(0, attributes.subjectLimit) + (attributes.subject.length > attributes.subjectLimit ? "..." : "");
  return /* @__PURE__ */ jsxs("div", { className: classNames("rce-container-mtitem", attributes.className), children: [
    /* @__PURE__ */ jsx(
      "audio",
      {
        autoPlay: true,
        loop: true,
        muted: attributes.audioMuted,
        src: attributes.audioSource
      }
    ),
    /* @__PURE__ */ jsxs("div", { className: "rce-mtitem", children: [
      /* @__PURE__ */ jsxs("div", { className: "rce-mtitem-top", children: [
        /* @__PURE__ */ jsx("div", { className: "rce-mtitem-subject", children: subject }),
        /* @__PURE__ */ jsx(
          "div",
          {
            className: "rce-mtitem-share",
            onClick: (event) => {
              var _a2;
              return (_a2 = attributes == null ? void 0 : attributes.onShare) == null ? void 0 : _a2.call(attributes, event, attributes, setAttributes);
            },
            onKeyDown: (event) => {
              var _a2;
              return (_a2 = attributes == null ? void 0 : attributes.onShare) == null ? void 0 : _a2.call(attributes, event, attributes, setAttributes);
            },
            children: /* @__PURE__ */ jsx(MdLink, {})
          }
        )
      ] }),
      /* @__PURE__ */ jsxs("div", { className: "rce-mtitem-body", children: [
        /* @__PURE__ */ jsxs("div", { className: "rce-mtitem-body--avatars", children: [
          (_b = attributes.avatars) == null ? void 0 : _b.slice(0, attributes.avatarLimit).map((x, i) => /* @__PURE__ */ jsx(
            Avatar_default,
            {
              title: x.title,
              src: x.src,
              alt: x.alt,
              className: x.statusColorType === "encircle" ? "rce-mtitem-avatar-encircle-status" : "",
              size: "small",
              letterItem: x.letterItem,
              sideElement: x.statusColor ? /* @__PURE__ */ jsx(
                "span",
                {
                  className: "rce-mtitem-status",
                  style: x.statusColorType === "encircle" ? {
                    boxShadow: `inset 0 0 0 2px ${x.statusColor}, inset 0 0 0 5px #FFFFFF`
                  } : {
                    backgroundColor: x.statusColor
                  },
                  children: x.statusText
                }
              ) : null,
              onError: attributes.onAvatarError,
              type: classNames("circle", {
                flexible: attributes.avatarFlexible
              })
            },
            i.toString()
          )),
          attributes.avatars && attributes.avatarLimit && attributes.avatars.length > attributes.avatarLimit && /* @__PURE__ */ jsx("div", { className: "rce-avatar-container circle small rce-mtitem-letter", children: /* @__PURE__ */ jsx("span", { children: `+${attributes.avatars.length - attributes.avatarLimit}` }) })
        ] }),
        /* @__PURE__ */ jsxs("div", { className: "rce-mtitem-body--functions", children: [
          attributes.closable && /* @__PURE__ */ jsx(
            "div",
            {
              className: "rce-mtitem-closable",
              onClick: (ev) => {
                var _a2;
                return (_a2 = attributes.onClose) == null ? void 0 : _a2.call(attributes, ev, attributes, setAttributes);
              },
              onKeyDown: (ev) => {
                var _a2;
                return (_a2 = attributes.onClose) == null ? void 0 : _a2.call(attributes, ev, attributes, setAttributes);
              },
              children: /* @__PURE__ */ jsx(MdCall, {})
            }
          ),
          /* @__PURE__ */ jsx(
            "div",
            {
              className: "rce-mtitem-button",
              onClick: (ev) => {
                var _a2;
                return (_a2 = attributes.onMeeting) == null ? void 0 : _a2.call(attributes, ev, attributes, setAttributes);
              },
              onKeyDown: (ev) => {
                var _a2;
                return (_a2 = attributes.onMeeting) == null ? void 0 : _a2.call(attributes, ev, attributes, setAttributes);
              },
              children: /* @__PURE__ */ jsx(MdVideoCall, {})
            }
          )
        ] })
      ] }),
      /* @__PURE__ */ jsx("div", { className: "rce-mtitem-footer", children: /* @__PURE__ */ jsx("span", { className: "rce-mtitem-date", children: attributes.dateString }) })
    ] })
  ] });
};
var MeetingItem_default = MeetingItem;

export {
  relativeDateFormat,
  MeetingItem_default
};
