import {
  relativeDateFormat
} from "./chunk-Y27BAB3M.mjs";
import {
  Badge_default
} from "./chunk-IK3UXS7Y.mjs";
import {
  Button_default
} from "./chunk-63HD37UK.mjs";
import {
  Avatar_default
} from "./chunk-KTYBYP2L.mjs";
import {
  __objRest,
  __spreadProps,
  __spreadValues
} from "./chunk-YUVL7GHC.mjs";

// src/ChatItem/ChatItem.tsx
import classNames from "classnames";
import { MdVideoCall, MdVolumeOff, MdVolumeUp } from "react-icons/md";
import { FaArrowDown, FaArrowUp } from "react-icons/fa";
import { cloneElement, useState } from "react";
import { Fragment, jsx, jsxs } from "react/jsx-runtime";
import { createElement } from "react";
var ChatItem = (_a) => {
  var _b = _a, {
    date = /* @__PURE__ */ new Date()
  } = _b, props = __objRest(_b, [
    "date"
  ]);
  var _a2, _b2, _c, _d;
  const [isExpanded, setIsExpanded] = useState(
    props.expanded || false
  );
  function getStatusItem() {
    var _a3;
    if ((props == null ? void 0 : props.statusColorType) === "badge") {
      return /* @__PURE__ */ jsx(
        Badge_default,
        {
          backgroundColor: props == null ? void 0 : props.statusColor,
          value: props == null ? void 0 : props.statusText,
          position: "top-right"
        }
      );
    }
    if ((props == null ? void 0 : props.statusColorType) === "encircle") {
      return /* @__PURE__ */ jsx(
        "span",
        {
          className: "rce-citem-status encircle",
          style: {
            borderColor: (_a3 = props == null ? void 0 : props.statusColor) != null ? _a3 : "var(--rce-color-green)"
          }
        }
      );
    }
    return null;
  }
  return /* @__PURE__ */ jsx("div", { className: classNames("rce-container-citem", props.className), children: /* @__PURE__ */ jsxs("div", { className: "rce-citem", children: [
    /* @__PURE__ */ jsxs(
      "div",
      {
        className: classNames("rce-citem-avatar", {
          "rce-citem-status-encircle": (props == null ? void 0 : props.statusColorType) === "encircle"
        }),
        children: [
          /* @__PURE__ */ jsx(
            Avatar_default,
            {
              src: props == null ? void 0 : props.avatar,
              alt: props.alt,
              title: props.title,
              className: (props == null ? void 0 : props.statusColorType) === "encircle" ? "rce-citem-avatar-encircle-status" : void 0,
              size: props.avatarSize || "default",
              letterItem: props.letterItem,
              sideElement: getStatusItem(),
              onError: props.onAvatarError,
              type: classNames("circle", {
                flexible: (props == null ? void 0 : props.avatarFlexible) === true
              })
            }
          ),
          ((_a2 = props == null ? void 0 : props.subList) == null ? void 0 : _a2.length) && /* @__PURE__ */ jsxs(Fragment, { children: [
            /* @__PURE__ */ jsx(
              Button_default,
              {
                link: true,
                className: "rce-citem-expand-button",
                onClick: () => setIsExpanded(!isExpanded),
                icon: {
                  component: isExpanded ? /* @__PURE__ */ jsx(FaArrowUp, {}) : /* @__PURE__ */ jsx(FaArrowDown, {})
                }
              }
            ),
            /* @__PURE__ */ jsx(
              "div",
              {
                className: "mce-citem-sublist",
                style: { display: props.expanded ? "block" : "none" },
                children: (_b2 = props.subList) == null ? void 0 : _b2.map((sub, i) => /* @__PURE__ */ createElement(
                  ChatItem,
                  __spreadProps(__spreadValues({}, sub), {
                    className: "subitem",
                    avatarSize: "xsmall",
                    key: `subitem-${i.toString()}`
                  })
                ))
              }
            )
          ] })
        ]
      }
    ),
    /* @__PURE__ */ jsxs("div", { className: "rce-citem-body", children: [
      /* @__PURE__ */ jsxs("div", { className: "rce-citem-body--top", children: [
        /* @__PURE__ */ jsx("div", { className: "rce-citem-body--top-title", children: props.title }),
        /* @__PURE__ */ jsx("div", { className: "rce-citem-body--top-time", children: date && (props.dateString || relativeDateFormat(date)) })
      ] }),
      /* @__PURE__ */ jsxs("div", { className: "rce-citem-body--bottom", children: [
        /* @__PURE__ */ jsx("div", { className: "rce-citem-body--bottom-title", children: props.subtitle }),
        /* @__PURE__ */ jsxs("div", { className: "rce-citem-body--bottom-elements", children: [
          /* @__PURE__ */ jsxs(
            "div",
            {
              className: "rce-citem-body--bottom-tools",
              onMouseEnter: props == null ? void 0 : props.handleOnMouseEnter,
              onMouseLeave: props == null ? void 0 : props.handleOnMouseLeave,
              children: [
                props.showMute ? /* @__PURE__ */ jsx(
                  Button_default,
                  {
                    link: true,
                    className: "rce-citem-body--bottom-tools-item",
                    onClick: (ev) => {
                      var _a3;
                      return (_a3 = props == null ? void 0 : props.onMuteToggle) == null ? void 0 : _a3.call(props, ev, props);
                    },
                    icon: {
                      component: (props == null ? void 0 : props.muted) ? /* @__PURE__ */ jsx(MdVolumeOff, {}) : /* @__PURE__ */ jsx(MdVolumeUp, {})
                    }
                  }
                ) : null,
                (props == null ? void 0 : props.showVideoCall) ? /* @__PURE__ */ jsx(
                  Button_default,
                  {
                    link: true,
                    className: "rce-citem-body--bottom-tools-item",
                    onClick: (ev) => {
                      var _a3;
                      return (_a3 = props == null ? void 0 : props.onVideoCall) == null ? void 0 : _a3.call(props, ev, props);
                    },
                    icon: { component: /* @__PURE__ */ jsx(MdVideoCall, {}) }
                  }
                ) : null
              ]
            }
          ),
          /* @__PURE__ */ jsx("div", { className: "rce-citem-body--bottom-tools-item-hidden-hover", children: (props == null ? void 0 : props.showMute) && (props == null ? void 0 : props.muted) && /* @__PURE__ */ jsx(
            Button_default,
            {
              link: true,
              className: "rce-citem-body--bottom-tools-item",
              onClick: (e) => {
                var _a3;
                return (_a3 = props == null ? void 0 : props.onMuteToggle) == null ? void 0 : _a3.call(props, e, props);
              },
              children: /* @__PURE__ */ jsx(MdVolumeOff, {})
            }
          ) }),
          (props == null ? void 0 : props.unread) ? /* @__PURE__ */ jsx(
            Badge_default,
            {
              className: "rce-citem-body--bottom-status",
              value: props.unread
            }
          ) : null,
          (_d = (_c = props == null ? void 0 : props.customStatusComponents) == null ? void 0 : _c.map(
            (el, index) => {
              return cloneElement(el, { key: index.toString() });
            }
          )) != null ? _d : null
        ] })
      ] })
    ] }, "rce-citem-body")
  ] }) });
};
var ChatItem_default = ChatItem;

export {
  ChatItem_default
};
