"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __pow = Math.pow;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.tsx
var src_exports = {};
__export(src_exports, {
  AudioMessage: () => AudioMessage_default,
  Avatar: () => Avatar_default,
  Button: () => Button_default,
  ChatItem: () => ChatItem_default,
  ChatList: () => ChatList_default,
  Dropdown: () => Dropdown_default,
  FileMessage: () => FileMessage_default,
  Input: () => Input_default,
  Loader: () => Loader_default,
  LocationMessage: () => LocationMessage_default,
  MeetingItem: () => MeetingItem_default,
  MeetingLink: () => MeetingLink_default,
  MeetingList: () => MeetingList_default,
  MeetingMessage: () => MeetingMessage_default,
  MessageBox: () => MessageBox_default,
  MessageList: () => MessageList_default,
  Navbar: () => Navbar_default,
  PhotoMessage: () => PhotoMessage_default,
  Popup: () => Popup_default,
  ReplyMessage: () => ReplyMessage_default,
  SideBar: () => SideBar_default,
  SystemMessage: () => SystemMessage_default,
  VideoMessage: () => VideoMessage_default
});
module.exports = __toCommonJS(src_exports);

// src/MessageBox/MessageBox.tsx
var import_react5 = require("react");
var import_classnames13 = __toESM(require("classnames"));

// src/PhotoMessage/PhotoMessage.tsx
var import_fa = require("react-icons/fa");

// src/Loader/Loader.tsx
var import_react = require("react");
var import_progressbar = require("progressbar.js");
var import_jsx_runtime = require("react/jsx-runtime");
var Loader = ({
  type = "circle",
  progressOptions = {
    strokeWidth: 6,
    easing: "easeInOut",
    duration: 1400,
    color: "#0791f1",
    trailColor: "#eee"
  },
  className,
  size = 100,
  progress = 0,
  style = {}
}) => {
  const wrapperRef = (0, import_react.useRef)(null);
  const loaderRef = (0, import_react.useRef)(null);
  const createWrapper = () => {
    const wrapper2 = document.createElement("div");
    wrapperRef.current = wrapper2;
    return wrapper2;
  };
  const wrapper = (0, import_react.useMemo)(createWrapper, []);
  (0, import_react.useEffect)(() => {
    const loader = type === "circle" ? new import_progressbar.Circle(wrapper, __spreadValues({
      strokeWidth: 6,
      easing: "easeInOut",
      duration: 1400,
      color: "#FFEA82",
      trailColor: "#eee",
      trailWidth: 1,
      svgStyle: null
    }, progressOptions)) : new import_progressbar.Line(wrapper, __spreadValues({
      strokeWidth: 4,
      easing: "easeInOut",
      duration: 1400,
      color: "#FFEA82",
      trailColor: "#eee",
      trailWidth: 1,
      svgStyle: { width: "100%", height: "100%" },
      text: {
        style: {
          color: "#999",
          position: "absolute",
          right: "0",
          top: "30px",
          padding: 0,
          margin: 0,
          transform: null
        },
        autoStyleContainer: false
      },
      from: { color: "#FFEA82" },
      to: { color: "#ED6A5A" },
      step: (state, bar) => {
        bar.setText(`${Math.round(bar.value() * 100)} %`);
      }
    }, progressOptions));
    loaderRef.current = loader;
    return () => {
      loader.destroy();
    };
  }, [wrapper, progressOptions, type]);
  (0, import_react.useEffect)(() => {
    if (loaderRef.current) {
      loaderRef.current.animate(progress * 0.01);
    }
  }, [progress]);
  const node = (0, import_react.useCallback)(
    (node2) => {
      if (node2) {
        node2.innerHTML = "";
        node2.appendChild(wrapper);
      }
    },
    [wrapper]
  );
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    "div",
    {
      className,
      ref: node,
      style: __spreadValues({ width: size, height: size }, style)
    }
  );
};
var Loader_default = Loader;

// src/PhotoMessage/PhotoMessage.tsx
var import_jsx_runtime2 = require("react/jsx-runtime");
var PhotoMessage = ({
  text,
  data,
  onDownload,
  onLoad,
  onOpen,
  onPhotoError
}) => {
  var _a, _b;
  const progressOptions = {
    strokeWidth: 2.3,
    color: "#efe",
    trailColor: "#aaa",
    trailWidth: 1,
    step: (state, circle) => {
      var _a2, _b2;
      circle.path.setAttribute("trail", (_a2 = state == null ? void 0 : state.state) == null ? void 0 : _a2.color);
      circle.path.setAttribute("trailwidth-width", (_b2 = state == null ? void 0 : state.state) == null ? void 0 : _b2.width);
      const value = Math.round(circle.value() * 100);
      if (value === 0) circle.setText("");
      else circle.setText(value);
    }
  };
  const error = (data == null ? void 0 : data.status) && (data == null ? void 0 : data.status.error) === true;
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "rce-mbox-photo", children: [
    /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(
      "div",
      {
        className: "rce-mbox-photo--img",
        style: __spreadValues({}, (data == null ? void 0 : data.width) && (data == null ? void 0 : data.height) && {
          width: data.width,
          height: data.height
        }),
        children: [
          /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
            "img",
            {
              src: data == null ? void 0 : data.uri,
              alt: data == null ? void 0 : data.alt,
              onClick: onOpen,
              onKeyDown: console.log,
              onLoad,
              onError: onPhotoError
            }
          ),
          error && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className: "rce-mbox-photo--img__block", children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("span", { className: "rce-mbox-photo--img__block-item rce-mbox-photo--error", children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_fa.FaExclamationTriangle, {}) }) }),
          !error && (data == null ? void 0 : data.status) && !((_a = data == null ? void 0 : data.status) == null ? void 0 : _a.download) && /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "rce-mbox-photo--img__block", children: [
            !(data == null ? void 0 : data.status.click) && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
              "button",
              {
                type: "button",
                onClick: onDownload,
                onKeyDown: console.log,
                className: "rce-mbox-photo--img__block-item rce-mbox-photo--download",
                children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_fa.FaCloudDownloadAlt, {})
              }
            ),
            typeof (data == null ? void 0 : data.status.loading) === "number" && (data == null ? void 0 : data.status.loading) !== 0 && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
              Loader_default,
              {
                animate: (_b = data == null ? void 0 : data.status.loading) != null ? _b : false,
                progressOptions,
                className: "rce-mbox-photo--img__block-item"
              }
            )
          ] })
        ]
      }
    ),
    text && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className: "rce-mbox-text", children: text })
  ] });
};
var PhotoMessage_default = PhotoMessage;

// src/FileMessage/FileMessage.tsx
var import_fa2 = require("react-icons/fa");
var import_classnames = __toESM(require("classnames"));
var import_jsx_runtime3 = require("react/jsx-runtime");
function formatFileSize(size) {
  if (typeof size === "string") {
    return size;
  }
  if (typeof size === "number") {
    return humanFileSize(size);
  }
  return "Unknown File Size";
}
function humanFileSize(bytes, decimals = 2) {
  if (bytes === 0) return "0 Bytes";
  const k = 1024;
  const dm = decimals || 2;
  const sizes = ["Bytes", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB"];
  const i = Math.floor(Math.log(bytes) / Math.log(k));
  return `${Number.parseFloat((bytes / __pow(k, i)).toFixed(dm))} ${sizes[i]}`;
}
var FileMessage = (props) => {
  var _a, _b, _c, _d, _e, _f, _g, _h, _i, _j, _k, _l, _m;
  const progressOptions = {
    strokeWidth: 6,
    easing: "easeInOut",
    duration: 1400,
    color: "var(--rce-color-primary)",
    trailColor: "var(--rce-color-gray-100)"
  };
  const error = ((_a = props == null ? void 0 : props.data) == null ? void 0 : _a.status) && ((_b = props == null ? void 0 : props.data) == null ? void 0 : _b.status.error) === true;
  const onClick = (e) => {
    var _a2, _b2, _c2;
    if (!((_a2 = props == null ? void 0 : props.data) == null ? void 0 : _a2.status)) return;
    if (!((_b2 = props == null ? void 0 : props.data) == null ? void 0 : _b2.status.download) && props.onDownload instanceof Function)
      props.onDownload(e);
    else if (((_c2 = props == null ? void 0 : props.data) == null ? void 0 : _c2.status.download) && props.onOpen instanceof Function)
      props.onOpen(e);
  };
  const filesize = formatFileSize((_c = props == null ? void 0 : props.data) == null ? void 0 : _c.size);
  return /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("div", { className: "rce-mbox-file", children: /* @__PURE__ */ (0, import_jsx_runtime3.jsxs)("button", { type: "button", onClick, children: [
    /* @__PURE__ */ (0, import_jsx_runtime3.jsxs)(
      "div",
      {
        className: (0, import_classnames.default)(
          "rce-mbox-file--icon",
          `rce-mbox-file-extension-${(_d = props == null ? void 0 : props.data) == null ? void 0 : _d.extension}`
        ),
        children: [
          /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(import_fa2.FaFile, { color: "#aaa" }),
          ((_e = props == null ? void 0 : props.data) == null ? void 0 : _e.size) ? /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("div", { className: "rce-mbox-file--size", children: filesize }) : null
        ]
      }
    ),
    /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("div", { className: "rce-mbox-file--text", children: (_f = props.data) == null ? void 0 : _f.name }),
    /* @__PURE__ */ (0, import_jsx_runtime3.jsxs)("div", { className: "rce-mbox-file--buttons", children: [
      error && /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("span", { className: "rce-error-button", children: /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(import_fa2.FaExclamationTriangle, { color: "#ff3d3d" }) }),
      !error && ((_g = props == null ? void 0 : props.data) == null ? void 0 : _g.status) && !((_h = props == null ? void 0 : props.data) == null ? void 0 : _h.status.download) && !((_i = props == null ? void 0 : props.data) == null ? void 0 : _i.status.click) && /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(import_fa2.FaCloudDownloadAlt, { color: "#aaa" }),
      !error && ((_j = props == null ? void 0 : props.data) == null ? void 0 : _j.status) && typeof ((_k = props == null ? void 0 : props.data) == null ? void 0 : _k.status.loading) === "number" && ((_l = props == null ? void 0 : props.data) == null ? void 0 : _l.status.loading) > 0 && /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(
        Loader_default,
        {
          animate: !!((_m = props == null ? void 0 : props.data) == null ? void 0 : _m.status.loading),
          className: "rce-mbox-file--loading",
          progressOptions
        }
      )
    ] })
  ] }) });
};
var FileMessage_default = FileMessage;

// src/SystemMessage/SystemMessage.tsx
var import_classnames2 = __toESM(require("classnames"));
var import_jsx_runtime4 = require("react/jsx-runtime");
var SystemMessage = (props) => {
  return /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { className: (0, import_classnames2.default)("rce-container-smsg", props.className), children: /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { className: "rce-smsg", children: /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { className: "rce-smsg-text", children: props.text }) }) });
};
var SystemMessage_default = SystemMessage;

// src/LocationMessage/LocationMessage.tsx
var import_classnames3 = __toESM(require("classnames"));

// src/constants.ts
var STATIC_URL = "https://www.openstreetmap.org/?map=ZOOM/LATITUDE/LONGITUDE";
var DATE_FORMAT = "yyyy-MM-dd HH:mm:ss";

// src/LocationMessage/Map.tsx
var import_react_leaflet = require("react-leaflet");
var import_leaflet = require("leaflet/dist/leaflet.css");
var import_leaflet2 = __toESM(require("leaflet"));
var import_jsx_runtime5 = require("react/jsx-runtime");
var markerIcon = import_leaflet2.default.icon({
  iconUrl: "https://unpkg.com/leaflet@1.9.3/dist/images/marker-icon.png",
  iconSize: [25, 41],
  iconAnchor: [12, 41],
  popupAnchor: [1, -34],
  shadowUrl: "https://unpkg.com/leaflet@1.9.3/dist/images/marker-shadow.png",
  shadowSize: [41, 41]
});
var MapElement = (props) => {
  const { latitude, longitude, zoom } = props;
  function LocationMarker(props2) {
    if (!props2) {
      return null;
    }
    const { latLng, markerText, markerColor } = props2;
    return latLng ? /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(import_react_leaflet.Marker, { position: latLng, icon: markerIcon, children: /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(import_react_leaflet.Popup, { children: markerText }) }) : null;
  }
  return /* @__PURE__ */ (0, import_jsx_runtime5.jsxs)(
    import_react_leaflet.MapContainer,
    {
      center: [latitude, longitude],
      zoom,
      scrollWheelZoom: false,
      children: [
        /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(
          import_react_leaflet.TileLayer,
          {
            attribution: '\xA9 <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors',
            url: "https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png"
          }
        ),
        props.marker && /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(LocationMarker, __spreadValues({}, props.marker))
      ]
    }
  );
};

// src/LocationMessage/LocationMessage.tsx
var import_jsx_runtime6 = require("react/jsx-runtime");
var LocationMessage = (props) => {
  var _a;
  const { latitude = 0, longitude = 0, zoom = 5 } = props;
  const buildURL = (url) => {
    return url.replace(/LATITUDE/g, latitude.toString()).replace(/LONGITUDE/g, longitude.toString()).replace("ZOOM", zoom.toString());
  };
  const className = () => {
    let _className = (0, import_classnames3.default)("rce-mbox-location", props.className);
    if (props.text) {
      _className = (0, import_classnames3.default)(_className, "rce-mbox-location-has-text");
    }
    return _className;
  };
  return /* @__PURE__ */ (0, import_jsx_runtime6.jsxs)("div", { className: "rce-container-lmsg", children: [
    /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(
      "a",
      {
        onClick: props.onOpen,
        target: (_a = props.target) != null ? _a : "_blank",
        href: props.href || props.src || buildURL((props == null ? void 0 : props.mapURL) || STATIC_URL),
        className: className(),
        children: /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(
          MapElement,
          __spreadValues({
            onError: props.onError,
            className: "rce-mbox-location-img h-full w-full"
          }, props)
        )
      }
    ),
    props.text && /* @__PURE__ */ (0, import_jsx_runtime6.jsx)("div", { className: "rce-mbox-text rce-mbox-location-text", children: props.text })
  ] });
};
var LocationMessage_default = LocationMessage;

// src/ReplyMessage/ReplyMessage.tsx
var import_classnames4 = __toESM(require("classnames"));
var import_jsx_runtime7 = require("react/jsx-runtime");
var ReplyMessage = (props) => {
  return /* @__PURE__ */ (0, import_jsx_runtime7.jsxs)(
    "div",
    {
      className: (0, import_classnames4.default)("rce-mbox-reply", {
        "rce-mbox-reply-border": !!props.titleColor
      }),
      style: __spreadValues({}, props.titleColor && { borderColor: props.titleColor }),
      onClick: props.onClick,
      onKeyDown: console.log,
      children: [
        /* @__PURE__ */ (0, import_jsx_runtime7.jsxs)("div", { className: "rce-mbox-reply-left", children: [
          /* @__PURE__ */ (0, import_jsx_runtime7.jsx)(
            "div",
            {
              style: __spreadValues({}, props.titleColor && { color: props.titleColor }),
              className: "rce-mbox-reply-owner",
              children: props.title
            }
          ),
          /* @__PURE__ */ (0, import_jsx_runtime7.jsx)("div", { className: "rce-mbox-reply-message", children: props.text || "..." })
        ] }),
        props.photoURL && /* @__PURE__ */ (0, import_jsx_runtime7.jsx)("div", { className: "rce-mbox-reply-right", children: /* @__PURE__ */ (0, import_jsx_runtime7.jsx)("img", { src: props.photoURL, alt: "" }) })
      ]
    }
  );
};
var ReplyMessage_default = ReplyMessage;

// src/MeetingMessage/MeetingMessage.tsx
var import_react3 = require("react");
var import_fa3 = require("react-icons/fa");
var import_hi = require("react-icons/hi");
var import_io = require("react-icons/io");
var import_md = require("react-icons/md");
var import_date_fns = require("date-fns");

// src/Avatar/Avatar.tsx
var import_classnames5 = __toESM(require("classnames"));

// src/Avatar/LetterAvatar.tsx
var import_jsx_runtime8 = require("react/jsx-runtime");
var stringToColor = (str) => {
  let hash = 0;
  for (let i = 0; i < str.length; i++) {
    hash = str.charCodeAt(i) + ((hash << 5) - hash);
  }
  let colour = "#";
  for (let i = 0; i < 3; i++) {
    let value = hash >> i * 8 & 255;
    value = value % 150 + 50;
    colour += `00${value.toString(16)}`.substr(-2);
  }
  return colour;
};
function getAvatarLetters(letterItem, title) {
  let name = "U";
  if (letterItem == null ? void 0 : letterItem.letter) {
    name = letterItem.letter;
  }
  if (title) {
    name = title;
  }
  return name.toUpperCase().split(" ").map((w) => w[0]).slice(0, 2).join("");
}
var LetterAvatar = (props) => {
  var _a, _b, _c;
  return /* @__PURE__ */ (0, import_jsx_runtime8.jsx)(
    "div",
    {
      className: "rce-avatar rce-avatar-letter-background",
      style: {
        backgroundColor: stringToColor(
          (_c = (_b = (_a = props.letterItem) == null ? void 0 : _a.id) != null ? _b : props == null ? void 0 : props.title) != null ? _c : "unknown"
        )
      },
      children: /* @__PURE__ */ (0, import_jsx_runtime8.jsx)(
        "svg",
        {
          role: "img",
          xmlns: "http://www.w3.org/2000/svg",
          viewBox: "0 0 50 50",
          className: "rce-avatar-letter",
          children: /* @__PURE__ */ (0, import_jsx_runtime8.jsx)(
            "text",
            {
              fill: "white",
              fontSize: "25",
              x: "50%",
              y: "50%",
              dominantBaseline: "central",
              textAnchor: "middle",
              children: getAvatarLetters(props == null ? void 0 : props.letterItem, props == null ? void 0 : props.title)
            }
          )
        }
      )
    }
  );
};

// src/Avatar/Avatar.tsx
var import_jsx_runtime9 = require("react/jsx-runtime");
var Avatar = (_a) => {
  var _b = _a, {
    size = "default",
    rounded = true
  } = _b, props = __objRest(_b, [
    "size",
    "rounded"
  ]);
  return /* @__PURE__ */ (0, import_jsx_runtime9.jsxs)(
    "div",
    {
      className: (0, import_classnames5.default)(
        "rce-avatar-container",
        size,
        props == null ? void 0 : props.className,
        rounded && "rounded"
      ),
      style: props == null ? void 0 : props.style,
      children: [
        props.letterItem || !(props == null ? void 0 : props.src) ? /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(LetterAvatar, __spreadValues({}, props)) : /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(
          "img",
          {
            loading: "lazy",
            alt: props == null ? void 0 : props.alt,
            src: props.src,
            className: "rce-avatar"
          }
        ),
        props == null ? void 0 : props.sideElement
      ]
    }
  );
};
var Avatar_default = Avatar;

// src/Dropdown/Dropdown.tsx
var import_react2 = require("react");
var import_classnames7 = __toESM(require("classnames"));

// src/Button/Button.tsx
var import_classnames6 = __toESM(require("classnames"));
var import_jsx_runtime10 = require("react/jsx-runtime");
var ButtonIcon = (props) => {
  var _a;
  return /* @__PURE__ */ (0, import_jsx_runtime10.jsx)("span", { className: "rce-button-icon--container", children: /* @__PURE__ */ (0, import_jsx_runtime10.jsx)(
    "span",
    {
      style: {
        float: (_a = props.float) != null ? _a : "inherit",
        fontSize: props.size || 12
      },
      className: "rce-button-icon",
      children: props.component
    }
  ) });
};
var Button = (_a) => {
  var _b = _a, {
    backgroundColor = "var(--rce-color-secondary)",
    color = "var(--rce-color-white)",
    style = {},
    borderWidth = 2,
    outlined,
    disabled,
    circle,
    squared,
    link,
    icon,
    buttonRef,
    text,
    className,
    children
  } = _b, rest = __objRest(_b, [
    "backgroundColor",
    "color",
    "style",
    "borderWidth",
    "outlined",
    "disabled",
    "circle",
    "squared",
    "link",
    "icon",
    "buttonRef",
    "text",
    "className",
    "children"
  ]);
  var _a2;
  return /* @__PURE__ */ (0, import_jsx_runtime10.jsxs)(
    "button",
    __spreadProps(__spreadValues({
      type: (_a2 = rest.type) != null ? _a2 : "button",
      ref: buttonRef,
      className: (0, import_classnames6.default)(
        "rce-button",
        className,
        outlined && "outlined",
        circle && "circle",
        link && "link",
        squared && "squared",
        disabled && "disabled"
      ),
      style: __spreadValues({
        backgroundColor: outlined ? color : backgroundColor,
        color: outlined ? backgroundColor : color,
        borderColor: backgroundColor,
        borderWidth,
        flexDirection: (icon == null ? void 0 : icon.float) === "left" ? "row-reverse" : "row"
      }, style)
    }, rest), {
      children: [
        children,
        text && /* @__PURE__ */ (0, import_jsx_runtime10.jsx)("span", { children: text }),
        (icon == null ? void 0 : icon.component) && /* @__PURE__ */ (0, import_jsx_runtime10.jsx)(ButtonIcon, __spreadValues({}, icon))
      ]
    })
  );
};
var Button_default = Button;

// src/Dropdown/Dropdown.tsx
var import_jsx_runtime11 = require("react/jsx-runtime");
var Dropdown = (_a) => {
  var _b = _a, {
    animationPosition = "northwest",
    animationType = "default",
    style = {}
  } = _b, props = __objRest(_b, [
    "animationPosition",
    "animationType",
    "style"
  ]);
  var _a2;
  const [show, setShow] = (0, import_react2.useState)(false);
  const onBlur = () => {
    if (show) {
      console.log("blur");
      setShow(false);
    }
  };
  return /* @__PURE__ */ (0, import_jsx_runtime11.jsxs)(
    "div",
    {
      className: (0, import_classnames7.default)("rce-dropdown-container", props.className),
      onBlur,
      children: [
        /* @__PURE__ */ (0, import_jsx_runtime11.jsx)(Button_default, __spreadProps(__spreadValues({}, props.buttonProps), { onClick: (e) => setShow(!show) })),
        /* @__PURE__ */ (0, import_jsx_runtime11.jsx)(
          "div",
          {
            className: (0, import_classnames7.default)(
              "rce-dropdown",
              animationType,
              `rce-dropdown-open__${animationPosition}`,
              { "dropdown-hide": !show },
              { "dropdown-show": show }
            ),
            style,
            children: /* @__PURE__ */ (0, import_jsx_runtime11.jsxs)("ul", { children: [
              props.title && /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("span", { className: "rce-dropdown-title", children: props.title }),
              (_a2 = props.items) == null ? void 0 : _a2.map((x, i) => {
                var _a3;
                return /* @__PURE__ */ (0, import_jsx_runtime11.jsx)(
                  "li",
                  {
                    onMouseDown: (e) => props.onSelect instanceof Function ? props.onSelect(e, i) : void 0,
                    children: typeof x !== "string" ? x.icon ? /* @__PURE__ */ (0, import_jsx_runtime11.jsxs)("span", { className: "rce-button-icon--container", children: [
                      (x.icon.float === "right" || !x.icon.float) && /* @__PURE__ */ (0, import_jsx_runtime11.jsx)(Button_default, __spreadValues({}, x)),
                      /* @__PURE__ */ (0, import_jsx_runtime11.jsx)(
                        "span",
                        {
                          style: {
                            float: (_a3 = x.icon.float) != null ? _a3 : "inherit",
                            color: String(x.icon.color) || "inherit",
                            fontSize: Number(x.icon.size) || 12
                          },
                          className: (0, import_classnames7.default)(
                            "rce-button-icon",
                            x.icon.className
                          ),
                          children: x.icon.component
                        }
                      ),
                      x.icon.float === "left" && /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("button", { type: "button", className: "rce-button link", children: x.text })
                    ] }) : /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("button", { type: "button", className: "rce-button link", children: x.text }) : /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("button", { type: "button", className: "rce-button link", children: x })
                  },
                  i.toString()
                );
              })
            ] })
          }
        )
      ]
    }
  );
};
var Dropdown_default = Dropdown;

// src/MeetingMessage/MeetingMessage.tsx
var import_classnames8 = __toESM(require("classnames"));
var import_jsx_runtime12 = require("react/jsx-runtime");
var MeetingMessage = (props) => {
  var _a, _b;
  const [toggle, setToggle] = (0, import_react3.useState)(false);
  const PARTICIPANT_LIMIT = props.participantsLimit || Number.POSITIVE_INFINITY;
  const dateText = props.dateString ? props.dateString : props.date && (0, import_date_fns.format)(props.date, DATE_FORMAT);
  return /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("div", { className: "rce-mbox-mtmg", children: /* @__PURE__ */ (0, import_jsx_runtime12.jsxs)("div", { className: "rce-mtmg", children: [
    /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("div", { className: "rce-mtmg-subject", children: props.subject || "Unknown Meeting" }),
    /* @__PURE__ */ (0, import_jsx_runtime12.jsxs)("div", { className: "rce-mtmg-body", children: [
      /* @__PURE__ */ (0, import_jsx_runtime12.jsxs)("div", { className: "rce-mtmg-item", children: [
        /* @__PURE__ */ (0, import_jsx_runtime12.jsx)(import_fa3.FaCalendar, {}),
        /* @__PURE__ */ (0, import_jsx_runtime12.jsxs)("div", { className: "rce-mtmg-content", children: [
          /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("span", { className: "rce-mtmg-title", children: props.title }),
          /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("span", { className: "rce-mtmg-date", children: dateText })
        ] })
      ] }),
      props.onMeetingMoreSelect && props.moreItems && props.moreItems.length > 0 && /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("div", { children: /* @__PURE__ */ (0, import_jsx_runtime12.jsx)(
        Dropdown_default,
        {
          animationType: "bottom",
          animationPosition: "northeast",
          buttonProps: {
            className: "rce-mtmg-right-icon",
            icon: {
              component: /* @__PURE__ */ (0, import_jsx_runtime12.jsx)(import_md.MdMoreHoriz, {}),
              size: 24
            }
          },
          items: props.moreItems,
          onSelect: (e) => {
            var _a2;
            return (_a2 = props.onMeetingMoreSelect) == null ? void 0 : _a2.call(props, e, props);
          }
        }
      ) })
    ] }),
    /* @__PURE__ */ (0, import_jsx_runtime12.jsx)(
      Button_default,
      {
        className: "rce-mtmg-body-bottom",
        link: true,
        onClick: () => setToggle(!toggle),
        icon: {
          component: toggle ? /* @__PURE__ */ (0, import_jsx_runtime12.jsx)(import_fa3.FaCaretDown, {}) : /* @__PURE__ */ (0, import_jsx_runtime12.jsx)(import_fa3.FaCaretRight, {})
        },
        text: toggle ? /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("div", { className: "rce-mtmg-bottom--tptitle", children: /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("span", { children: props.collapseTitle }) }) : /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("div", { className: "rce-mtmg-body-bottom--bttitle", children: /* @__PURE__ */ (0, import_jsx_runtime12.jsxs)("span", { children: [
          (_a = props.participants) == null ? void 0 : _a.slice(0, PARTICIPANT_LIMIT).map((x) => x.title || "Unknown").join(", "),
          props.participants && PARTICIPANT_LIMIT && props.participants.length > PARTICIPANT_LIMIT && `, +${props.participants.length - PARTICIPANT_LIMIT}`
        ] }) })
      }
    ),
    /* @__PURE__ */ (0, import_jsx_runtime12.jsx)(
      "div",
      {
        className: (0, import_classnames8.default)("rce-mtmg-toogleContent", {
          "rce-mtmg-toogleContent--click": toggle
        }),
        children: (_b = props.dataSource) == null ? void 0 : _b.map((x, i) => {
          var _a2, _b2;
          return /* @__PURE__ */ (0, import_jsx_runtime12.jsxs)("div", { children: [
            !x.event && /* @__PURE__ */ (0, import_jsx_runtime12.jsxs)("div", { className: "rce-mitem", children: [
              /* @__PURE__ */ (0, import_jsx_runtime12.jsx)(
                "div",
                {
                  className: (0, import_classnames8.default)("rce-mitem avatar", {
                    "rce-mitem no-avatar": !x.avatar
                  }),
                  children: x.avatar ? /* @__PURE__ */ (0, import_jsx_runtime12.jsx)(Avatar_default, { title: x.title || "Unknown", src: x.avatar }) : /* @__PURE__ */ (0, import_jsx_runtime12.jsx)(import_io.IoMdChatboxes, {})
                }
              ),
              /* @__PURE__ */ (0, import_jsx_runtime12.jsxs)("div", { className: "rce-mitem-body", children: [
                /* @__PURE__ */ (0, import_jsx_runtime12.jsxs)("div", { className: "rce-mitem-body--top", children: [
                  /* @__PURE__ */ (0, import_jsx_runtime12.jsx)(
                    "div",
                    {
                      className: "rce-mitem-body--top-title",
                      onClick: (e) => {
                        var _a3;
                        return (_a3 = props.onMeetingLink) == null ? void 0 : _a3.call(props, e, props);
                      },
                      onKeyDown: console.log,
                      children: x.title
                    }
                  ),
                  /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("div", { className: "rce-mitem-body--top-time", children: x.dateString ? x.dateString : x.date && x.date && (0, import_date_fns.format)(x.date, DATE_FORMAT) })
                ] }),
                /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("div", { className: "rce-mitem-body--bottom", children: /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("div", { className: "rce-mitem-body--bottom-title", children: x.message }) })
              ] })
            ] }),
            x.event && /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("div", { className: "rce-mitem-event", children: /* @__PURE__ */ (0, import_jsx_runtime12.jsxs)("div", { className: "rce-mitem-bottom-body", children: [
              /* @__PURE__ */ (0, import_jsx_runtime12.jsxs)("div", { className: "rce-mitem-event-wrapper", children: [
                /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("div", { className: "rce-mitem-body avatar", children: /* @__PURE__ */ (0, import_jsx_runtime12.jsx)(import_hi.HiOutlineVideoCamera, {}) }),
                /* @__PURE__ */ (0, import_jsx_runtime12.jsxs)("div", { className: "rce-mitem-bottom-body-top", children: [
                  x.event.title,
                  /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("div", { className: "rce-mitem-body--top-time", children: x.dateString ? x.dateString : x.date && (0, import_date_fns.format)(x.date, "yyyy-MM-dd HH:mm") }),
                  /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("div", { className: "rce-mitem-avatar-content", children: /* @__PURE__ */ (0, import_jsx_runtime12.jsxs)("div", { className: "rce-mitem-avatar", children: [
                    (_b2 = x.event.avatars) == null ? void 0 : _b2.slice(0, PARTICIPANT_LIMIT).map((x2, i2) => /* @__PURE__ */ (0, import_jsx_runtime12.jsx)(
                      Avatar_default,
                      {
                        title: x2.title,
                        src: x2.src,
                        size: "small"
                      },
                      i2.toString()
                    )),
                    x.event.avatars && x.event.avatarsLimit && x.event.avatars.length > x.event.avatarsLimit && /* @__PURE__ */ (0, import_jsx_runtime12.jsx)(
                      "div",
                      {
                        className: "rce-mitem-length rce-mitem-tooltip",
                        tooltip: x.event.avatars.slice(
                          x.event.avatarsLimit,
                          x.event.avatars.length
                        ).map((avatar) => avatar.title).join(",").toString(),
                        children: /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("span", { className: "rce-mitem-tooltip-text", children: `+${x.event.avatars.length - x.event.avatarsLimit}` })
                      }
                    )
                  ] }) })
                ] })
              ] }),
              x.record && /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("div", { className: "rce-mtmg-call-record", children: /* @__PURE__ */ (0, import_jsx_runtime12.jsxs)("div", { className: "rce-mtmg-call-body", children: [
                /* @__PURE__ */ (0, import_jsx_runtime12.jsxs)(
                  "div",
                  {
                    onClick: (e) => {
                      var _a3;
                      return (_a3 = props.onMeetingVideoLink) == null ? void 0 : _a3.call(props, e, props);
                    },
                    onKeyDown: (e) => {
                      var _a3;
                      return (_a3 = props.onMeetingVideoLink) == null ? void 0 : _a3.call(props, e, props);
                    },
                    className: "rce-mtmg-call-avatars",
                    children: [
                      /* @__PURE__ */ (0, import_jsx_runtime12.jsx)(
                        "img",
                        {
                          alt: "Meeting poster",
                          className: "rce-mtmg-call-avatars",
                          src: x.record.cover
                        }
                      ),
                      /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("div", { className: "rce-mtmg-record-time", children: x.record.time })
                    ]
                  }
                ),
                /* @__PURE__ */ (0, import_jsx_runtime12.jsxs)("div", { className: "rce-mtmg-call-body-title", children: [
                  /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("span", { children: x.record.title }),
                  /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("div", { className: "rce-mtmg-call-body-bottom", children: x.record.savedBy })
                ] })
              ] }) })
            ] }) })
          ] }, (_a2 = x.id) != null ? _a2 : i.toString());
        })
      }
    )
  ] }) });
};
var MeetingMessage_default = MeetingMessage;

// src/VideoMessage/VideoMessage.tsx
var import_fa4 = require("react-icons/fa");
var import_classnames9 = __toESM(require("classnames"));
var import_jsx_runtime13 = require("react/jsx-runtime");
var VideoMessage = (props) => {
  var _a, _b, _c, _d, _e, _f, _g, _h, _i;
  const progressOptions = {
    strokeWidth: 2.3,
    color: "#efe",
    trailColor: "#aaa",
    trailWidth: 1,
    step: (data, circle) => {
      var _a2, _b2;
      circle.path.setAttribute("trail", ((_a2 = data == null ? void 0 : data.state) == null ? void 0 : _a2.color) || "");
      circle.path.setAttribute("trailwidth-width", ((_b2 = data == null ? void 0 : data.state) == null ? void 0 : _b2.width) || "");
      const value = Math.round((circle == null ? void 0 : circle.value()) * 100);
      if (value === 0) circle == null ? void 0 : circle.setText("");
      else circle == null ? void 0 : circle.setText(value);
    }
  };
  const error = ((_a = props == null ? void 0 : props.data) == null ? void 0 : _a.status) && ((_b = props == null ? void 0 : props.data) == null ? void 0 : _b.status.error) === true;
  const downloaded = (_d = (_c = props == null ? void 0 : props.data) == null ? void 0 : _c.status) == null ? void 0 : _d.download;
  return /* @__PURE__ */ (0, import_jsx_runtime13.jsxs)(
    "div",
    {
      className: (0, import_classnames9.default)("rce-mbox-video", {
        "padding-time": !(props == null ? void 0 : props.text)
      }),
      children: [
        /* @__PURE__ */ (0, import_jsx_runtime13.jsxs)(
          "div",
          {
            className: "rce-mbox-video--video",
            style: __spreadValues({}, ((_e = props == null ? void 0 : props.data) == null ? void 0 : _e.width) && ((_f = props == null ? void 0 : props.data) == null ? void 0 : _f.height) && {
              width: props.data.width,
              height: props.data.height
            }),
            children: [
              !downloaded && /* @__PURE__ */ (0, import_jsx_runtime13.jsx)(
                "img",
                {
                  src: (_g = props == null ? void 0 : props.data) == null ? void 0 : _g.uri,
                  alt: (_h = props == null ? void 0 : props.data) == null ? void 0 : _h.alt,
                  onClick: props.onOpen,
                  onKeyDown: console.log,
                  onLoad: props.onLoad,
                  onError: props.onPhotoError
                }
              ),
              downloaded && /* @__PURE__ */ (0, import_jsx_runtime13.jsxs)("video", { controls: true, controlsList: props.controlsList, children: [
                /* @__PURE__ */ (0, import_jsx_runtime13.jsx)("source", { src: props == null ? void 0 : props.data.videoURL, type: "video/mp4" }),
                /* @__PURE__ */ (0, import_jsx_runtime13.jsx)("track", { src: props == null ? void 0 : props.data.videoCaptionsURL, kind: "captions" }),
                "Your browser does not support HTML video."
              ] }),
              error && /* @__PURE__ */ (0, import_jsx_runtime13.jsx)("div", { className: "rce-mbox-video--video__block", children: /* @__PURE__ */ (0, import_jsx_runtime13.jsx)("span", { className: "rce-mbox-video--video__block-item rce-mbox-video--error", children: /* @__PURE__ */ (0, import_jsx_runtime13.jsx)(import_fa4.FaExclamationTriangle, {}) }) }),
              !error && ((_i = props == null ? void 0 : props.data) == null ? void 0 : _i.status) && !downloaded && /* @__PURE__ */ (0, import_jsx_runtime13.jsxs)("div", { className: "rce-mbox-video--video__block", children: [
                !props.data.status.click && /* @__PURE__ */ (0, import_jsx_runtime13.jsx)(
                  "button",
                  {
                    type: "button",
                    onClick: props.onDownload,
                    className: "rce-mbox-video--video__block-item rce-mbox-video--download",
                    children: /* @__PURE__ */ (0, import_jsx_runtime13.jsx)(import_fa4.FaCloudDownloadAlt, {})
                  }
                ),
                typeof props.data.status.loading === "number" && props.data.status.loading !== 0 && /* @__PURE__ */ (0, import_jsx_runtime13.jsx)(
                  Loader_default,
                  {
                    animate: props.data.status.loading,
                    className: "rce-mbox-video--video__block-item",
                    progressOptions
                  }
                )
              ] })
            ]
          }
        ),
        (props == null ? void 0 : props.text) && /* @__PURE__ */ (0, import_jsx_runtime13.jsx)("div", { className: "rce-mbox-text", children: props.text })
      ]
    }
  );
};
var VideoMessage_default = VideoMessage;

// src/AudioMessage/AudioMessage.tsx
var import_jsx_runtime14 = require("react/jsx-runtime");
var AudioMessage = (props) => {
  var _a, _b, _c, _d;
  const controlsList = (_b = (_a = props.data) == null ? void 0 : _a.controlsList) != null ? _b : "nodownload";
  return /* @__PURE__ */ (0, import_jsx_runtime14.jsxs)("div", { className: "rce-mbox-audio", style: props.customStyle, children: [
    /* @__PURE__ */ (0, import_jsx_runtime14.jsxs)("audio", __spreadProps(__spreadValues({}, props.audioProps), { controls: true, controlsList, children: [
      /* @__PURE__ */ (0, import_jsx_runtime14.jsx)(
        "source",
        {
          src: props.data.audioURL,
          type: (_d = (_c = props.data) == null ? void 0 : _c.audioType) != null ? _d : "audio/mp3"
        }
      ),
      "Your browser does not support the audio element."
    ] })),
    props.text && /* @__PURE__ */ (0, import_jsx_runtime14.jsx)("div", { className: "rce-mbox-text", children: props.text })
  ] });
};
var AudioMessage_default = AudioMessage;

// src/MeetingLink/MeetingLink.tsx
var import_jsx_runtime15 = require("react/jsx-runtime");
var MeetingLink = (props) => {
  var _a;
  return /* @__PURE__ */ (0, import_jsx_runtime15.jsx)("div", { className: "rce-mtlink", children: /* @__PURE__ */ (0, import_jsx_runtime15.jsxs)("div", { className: "rce-mtlink-content", children: [
    /* @__PURE__ */ (0, import_jsx_runtime15.jsx)("div", { className: "rce-mtlink-item", children: /* @__PURE__ */ (0, import_jsx_runtime15.jsx)("div", { className: "rce-mtlink-title", children: props.text }) }),
    /* @__PURE__ */ (0, import_jsx_runtime15.jsx)("div", { className: "rce-mtlink-btn", children: (_a = props == null ? void 0 : props.actionButtons) == null ? void 0 : _a.map(
      (Item, index) => {
        return /* @__PURE__ */ (0, import_jsx_runtime15.jsx)(
          "div",
          {
            className: "rce-mtlink-btn-content",
            onClick: () => {
              var _a2;
              return Item.onClickButton((_a2 = props == null ? void 0 : props.meetingID) != null ? _a2 : "");
            },
            onKeyDown: console.log,
            children: Item.Component
          },
          `${props == null ? void 0 : props.id}-${index.toString()}`
        );
      }
    ) })
  ] }) });
};
var MeetingLink_default = MeetingLink;

// src/MessageBox/MessageBox.tsx
var import_md4 = require("react-icons/md");
var import_date_fns3 = require("date-fns");

// src/SvgIcon/icons.tsx
var import_jsx_runtime16 = require("react/jsx-runtime");
var SVG = (_a) => {
  var _b = _a, {
    children,
    size = 24,
    style = {},
    className = ""
  } = _b, props = __objRest(_b, [
    "children",
    "size",
    "style",
    "className"
  ]);
  return /* @__PURE__ */ (0, import_jsx_runtime16.jsx)(
    "svg",
    __spreadProps(__spreadValues({
      xmlns: "http://www.w3.org/2000/svg",
      role: "img",
      viewBox: `0 0 ${size} ${size}`,
      height: size,
      width: size
    }, props), {
      style: __spreadValues({
        display: "inline-flex",
        verticalAlign: "middle",
        fill: "currentColor"
      }, style),
      className,
      children
    })
  );
};
var icons_default = SVG;

// src/SvgIcon/leftNotch.tsx
var import_classnames10 = __toESM(require("classnames"));
var import_jsx_runtime17 = require("react/jsx-runtime");
var LeftNotch = ({
  size = 20,
  style = {},
  focus = false
}) => {
  return /* @__PURE__ */ (0, import_jsx_runtime17.jsx)(
    icons_default,
    {
      style,
      className: (0, import_classnames10.default)("rce-mbox-left-notch", {
        "message-focus": focus
      }),
      size,
      children: /* @__PURE__ */ (0, import_jsx_runtime17.jsx)("path", { d: `M${size} 0v${size}L0 0` })
    }
  );
};

// src/SvgIcon/rightNotch.tsx
var import_classnames11 = __toESM(require("classnames"));
var import_jsx_runtime18 = require("react/jsx-runtime");
var RightNotch = ({
  style = {},
  focus = false
}) => {
  return /* @__PURE__ */ (0, import_jsx_runtime18.jsx)(
    icons_default,
    {
      style,
      className: (0, import_classnames11.default)("rce-mbox-right-notch", {
        "message-focus": focus
      }),
      size: 20,
      children: /* @__PURE__ */ (0, import_jsx_runtime18.jsx)("path", { d: "M0 0v20L20 0" })
    }
  );
};

// src/MeetingItem/MeetingItem.tsx
var import_md2 = require("react-icons/md");
var import_date_fns2 = require("date-fns");
var import_classnames12 = __toESM(require("classnames"));
var import_react4 = require("react");
var import_jsx_runtime19 = require("react/jsx-runtime");
var relativeDateFormat = (date = /* @__PURE__ */ new Date()) => {
  let dateObject;
  try {
    if (date instanceof Date) {
      dateObject = date;
    } else {
      dateObject = new Date(date);
    }
  } catch (error) {
    dateObject = /* @__PURE__ */ new Date();
    console.error("the date provided is not valid", error);
  }
  return (0, import_date_fns2.formatDistance)(dateObject, /* @__PURE__ */ new Date(), {
    addSuffix: true
  }).replace("less than a minute ago", "now");
};
var MeetingItem = (props) => {
  var _a, _b;
  const [attributes, setAttributes] = (0, import_react4.useState)(__spreadValues({
    subjectLimit: 60,
    avatarFlexible: false,
    date: /* @__PURE__ */ new Date(),
    avatarLimit: 5,
    avatars: [],
    audioMuted: true,
    dateString: (_a = props.dateString) != null ? _a : relativeDateFormat(props.date)
  }, props));
  const subject = attributes.subject && attributes.subjectLimit && attributes.subject.substring(0, attributes.subjectLimit) + (attributes.subject.length > attributes.subjectLimit ? "..." : "");
  return /* @__PURE__ */ (0, import_jsx_runtime19.jsxs)("div", { className: (0, import_classnames12.default)("rce-container-mtitem", attributes.className), children: [
    /* @__PURE__ */ (0, import_jsx_runtime19.jsx)(
      "audio",
      {
        autoPlay: true,
        loop: true,
        muted: attributes.audioMuted,
        src: attributes.audioSource
      }
    ),
    /* @__PURE__ */ (0, import_jsx_runtime19.jsxs)("div", { className: "rce-mtitem", children: [
      /* @__PURE__ */ (0, import_jsx_runtime19.jsxs)("div", { className: "rce-mtitem-top", children: [
        /* @__PURE__ */ (0, import_jsx_runtime19.jsx)("div", { className: "rce-mtitem-subject", children: subject }),
        /* @__PURE__ */ (0, import_jsx_runtime19.jsx)(
          "div",
          {
            className: "rce-mtitem-share",
            onClick: (event) => {
              var _a2;
              return (_a2 = attributes == null ? void 0 : attributes.onShare) == null ? void 0 : _a2.call(attributes, event, attributes, setAttributes);
            },
            onKeyDown: (event) => {
              var _a2;
              return (_a2 = attributes == null ? void 0 : attributes.onShare) == null ? void 0 : _a2.call(attributes, event, attributes, setAttributes);
            },
            children: /* @__PURE__ */ (0, import_jsx_runtime19.jsx)(import_md2.MdLink, {})
          }
        )
      ] }),
      /* @__PURE__ */ (0, import_jsx_runtime19.jsxs)("div", { className: "rce-mtitem-body", children: [
        /* @__PURE__ */ (0, import_jsx_runtime19.jsxs)("div", { className: "rce-mtitem-body--avatars", children: [
          (_b = attributes.avatars) == null ? void 0 : _b.slice(0, attributes.avatarLimit).map((x, i) => /* @__PURE__ */ (0, import_jsx_runtime19.jsx)(
            Avatar_default,
            {
              title: x.title,
              src: x.src,
              alt: x.alt,
              className: x.statusColorType === "encircle" ? "rce-mtitem-avatar-encircle-status" : "",
              size: "small",
              letterItem: x.letterItem,
              sideElement: x.statusColor ? /* @__PURE__ */ (0, import_jsx_runtime19.jsx)(
                "span",
                {
                  className: "rce-mtitem-status",
                  style: x.statusColorType === "encircle" ? {
                    boxShadow: `inset 0 0 0 2px ${x.statusColor}, inset 0 0 0 5px #FFFFFF`
                  } : {
                    backgroundColor: x.statusColor
                  },
                  children: x.statusText
                }
              ) : null,
              onError: attributes.onAvatarError,
              type: (0, import_classnames12.default)("circle", {
                flexible: attributes.avatarFlexible
              })
            },
            i.toString()
          )),
          attributes.avatars && attributes.avatarLimit && attributes.avatars.length > attributes.avatarLimit && /* @__PURE__ */ (0, import_jsx_runtime19.jsx)("div", { className: "rce-avatar-container circle small rce-mtitem-letter", children: /* @__PURE__ */ (0, import_jsx_runtime19.jsx)("span", { children: `+${attributes.avatars.length - attributes.avatarLimit}` }) })
        ] }),
        /* @__PURE__ */ (0, import_jsx_runtime19.jsxs)("div", { className: "rce-mtitem-body--functions", children: [
          attributes.closable && /* @__PURE__ */ (0, import_jsx_runtime19.jsx)(
            "div",
            {
              className: "rce-mtitem-closable",
              onClick: (ev) => {
                var _a2;
                return (_a2 = attributes.onClose) == null ? void 0 : _a2.call(attributes, ev, attributes, setAttributes);
              },
              onKeyDown: (ev) => {
                var _a2;
                return (_a2 = attributes.onClose) == null ? void 0 : _a2.call(attributes, ev, attributes, setAttributes);
              },
              children: /* @__PURE__ */ (0, import_jsx_runtime19.jsx)(import_md2.MdCall, {})
            }
          ),
          /* @__PURE__ */ (0, import_jsx_runtime19.jsx)(
            "div",
            {
              className: "rce-mtitem-button",
              onClick: (ev) => {
                var _a2;
                return (_a2 = attributes.onMeeting) == null ? void 0 : _a2.call(attributes, ev, attributes, setAttributes);
              },
              onKeyDown: (ev) => {
                var _a2;
                return (_a2 = attributes.onMeeting) == null ? void 0 : _a2.call(attributes, ev, attributes, setAttributes);
              },
              children: /* @__PURE__ */ (0, import_jsx_runtime19.jsx)(import_md2.MdVideoCall, {})
            }
          )
        ] })
      ] }),
      /* @__PURE__ */ (0, import_jsx_runtime19.jsx)("div", { className: "rce-mtitem-footer", children: /* @__PURE__ */ (0, import_jsx_runtime19.jsx)("span", { className: "rce-mtitem-date", children: attributes.dateString }) })
    ] })
  ] });
};
var MeetingItem_default = MeetingItem;

// src/MessageBox/Reactions.tsx
var import_jsx_runtime20 = require("react/jsx-runtime");
function Reactions(props) {
  var _a;
  if (!props.reactions) {
    return null;
  }
  return /* @__PURE__ */ (0, import_jsx_runtime20.jsx)("div", { className: "rce-reactions", children: (_a = props.reactions) == null ? void 0 : _a.map((reaction) => /* @__PURE__ */ (0, import_jsx_runtime20.jsx)(
    "div",
    {
      className: "rce-reaction",
      title: `${reaction.author} reacted with ${reaction.emoji}`,
      children: reaction.emoji
    },
    reaction.emoji
  )) });
}

// src/MessageBox/MessageStatus.tsx
var import_md3 = require("react-icons/md");
var import_jsx_runtime21 = require("react/jsx-runtime");
function MessageStatus({ status }) {
  return /* @__PURE__ */ (0, import_jsx_runtime21.jsxs)("span", { className: "rce-mbox-status", children: [
    status === "waiting" && /* @__PURE__ */ (0, import_jsx_runtime21.jsx)(
      import_md3.MdAccessTime,
      {
        color: "var(--rce-color-gray)",
        style: { fontSize: 18 }
      }
    ),
    status === "sent" && /* @__PURE__ */ (0, import_jsx_runtime21.jsx)(
      import_md3.MdCheck,
      {
        color: "var(--rce-color-light-blue)",
        style: { fontSize: 18 }
      }
    ),
    status === "received" && /* @__PURE__ */ (0, import_jsx_runtime21.jsx)(import_md3.MdDoneAll, { color: "var(--rce-color-green)", style: { fontSize: 18 } }),
    status === "read" && /* @__PURE__ */ (0, import_jsx_runtime21.jsx)(
      import_md3.MdDoneAll,
      {
        color: "var(--rce-color-light-blue)",
        style: { fontSize: 18 }
      }
    )
  ] });
}

// src/MessageBox/MessageBox.tsx
var import_jsx_runtime22 = require("react/jsx-runtime");
var MessageBox = (props) => {
  const prevProps = (0, import_react5.useRef)(props.focus);
  const messageRef = (0, import_react5.useRef)(null);
  const positionCls = (0, import_classnames13.default)(
    "rce-mbox",
    `rce-mbox-${props.position === "right" ? "right" : "left"}`
  );
  const defaultActionStyle = {
    color: "var(--rce-color-white)",
    backgroundColor: "rgba(110, 110, 120, .5)",
    style: {
      padding: "6px",
      borderWidth: 0
    }
  };
  const thatAbsoluteTime = !/(text|video|file|meeting|audio)/g.test(props.type || "text") && !(props.type === "location" && props.text);
  const dateText = props.date && (props.dateString || (0, import_date_fns3.format)(props.date, "HH:mm"));
  (0, import_react5.useEffect)(() => {
    var _a;
    if (prevProps.current !== props.focus && props.focus) {
      if (messageRef == null ? void 0 : messageRef.current) {
        (_a = messageRef.current) == null ? void 0 : _a.scrollIntoView({
          behavior: "smooth",
          block: "nearest",
          inline: "start"
        });
        if (props == null ? void 0 : props.onMessageFocused) props.onMessageFocused(true);
      }
    }
    prevProps.current = props.focus;
  }, [props.focus, props.onMessageFocused]);
  return /* @__PURE__ */ (0, import_jsx_runtime22.jsxs)(
    "div",
    {
      ref: messageRef,
      className: (0, import_classnames13.default)("rce-container-mbox", props.className),
      children: [
        props == null ? void 0 : props.renderAddCmp,
        props.type === "system" ? /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(SystemMessage_default, __spreadValues({}, props)) : /* @__PURE__ */ (0, import_jsx_runtime22.jsxs)(
          "div",
          {
            className: (0, import_classnames13.default)(
              positionCls,
              { "rce-mbox--clear-padding": thatAbsoluteTime },
              { "rce-mbox--clear-notch": !!(props == null ? void 0 : props.notch) }
            ),
            children: [
              (props == null ? void 0 : props.notch) !== false && (props.position === "right" ? /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(
                RightNotch,
                {
                  style: __spreadValues({
                    fill: "var(--rce-mbox-background-right)"
                  }, props.notchStyle),
                  focus: props.focus
                }
              ) : /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(
                LeftNotch,
                {
                  style: __spreadValues({
                    fill: "var(--rce-mbox-background)"
                  }, props.notchStyle),
                  focus: props.focus
                }
              )),
              /* @__PURE__ */ (0, import_jsx_runtime22.jsxs)(
                "div",
                {
                  className: (0, import_classnames13.default)("rce-mbox-body", {
                    "message-focus": props.focus
                  }),
                  onContextMenu: props == null ? void 0 : props.onContextMenu,
                  style: props.style,
                  children: [
                    /* @__PURE__ */ (0, import_jsx_runtime22.jsxs)("div", { className: "rce-mbox-action-buttons", children: [
                      !props.retracted && props.EmojiButton === true && /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(
                        Button_default,
                        __spreadValues({
                          circle: true,
                          className: (0, import_classnames13.default)(
                            "rce-mbox-action",
                            "rce-mbox-emoji-button",
                            {
                              "rce-mbox-forward-right": props.position === "left"
                            },
                            {
                              "rce-mbox-forward-left": props.position === "right"
                            }
                          ),
                          onClick: (e) => {
                            var _a;
                            return (_a = props == null ? void 0 : props.AddEmoji) == null ? void 0 : _a.call(props, e, props);
                          },
                          icon: {
                            component: /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(import_md4.MdOutlineEmojiEmotions, { size: 20 })
                          }
                        }, defaultActionStyle)
                      ),
                      !props.retracted && !props.forwarded && /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(
                        Button_default,
                        __spreadValues({
                          circle: true,
                          className: (0, import_classnames13.default)(
                            "rce-mbox-action",
                            "rce-mbox-forward",
                            `rce-mbox-forward-${props.position === "right" ? "right" : "left"}`
                          ),
                          onClick: (e) => {
                            var _a;
                            return (_a = props.onForward) == null ? void 0 : _a.call(props, e, props);
                          },
                          icon: {
                            component: /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(
                              import_md4.MdReplyAll,
                              {
                                size: 20,
                                className: "reverse-icon-horizontal"
                              }
                            )
                          }
                        }, defaultActionStyle)
                      ),
                      !props.retracted && props.replyButton && /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(
                        Button_default,
                        __spreadValues({
                          circle: true,
                          className: !props.forwarded ? (0, import_classnames13.default)(
                            "rce-mbox-action",
                            "rce-mbox-forward",
                            `rce-mbox-forward-${props.position}`
                          ) : (0, import_classnames13.default)(
                            "rce-mbox-action",
                            "rce-mbox-forward",
                            `rce-mbox-reply-btn-${props.position}`
                          ),
                          onClick: (ev) => {
                            var _a;
                            return (_a = props.onReplyMessage) == null ? void 0 : _a.call(props, ev, props);
                          },
                          icon: {
                            component: /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(
                              import_md4.MdReply,
                              {
                                size: 20,
                                className: "reverse-icon-horizontal"
                              }
                            )
                          }
                        }, defaultActionStyle)
                      ),
                      !props.retracted && props.removeButton && /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(
                        Button_default,
                        __spreadValues({
                          circle: true,
                          className: props.forwarded ? (0, import_classnames13.default)(
                            "rce-mbox-action",
                            "rce-mbox-remove",
                            `rce-mbox-remove-${props.position}`
                          ) : (0, import_classnames13.default)(
                            "rce-mbox-action",
                            "rce-mbox-forward",
                            `rce-mbox-reply-btn-${props.position}`
                          ),
                          onClick: (ev) => {
                            var _a;
                            return (_a = props.onRemoveMessage) == null ? void 0 : _a.call(props, ev, props);
                          },
                          icon: {
                            component: /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(import_md4.MdDelete, { size: 20 })
                          }
                        }, defaultActionStyle)
                      )
                    ] }),
                    (props.title || props.avatar) && /* @__PURE__ */ (0, import_jsx_runtime22.jsxs)(
                      Button_default,
                      {
                        link: true,
                        style: __spreadValues({}, props.titleColor && {
                          color: props.titleColor
                        }),
                        onClick: (event) => {
                          var _a;
                          return (_a = props.onTitleClick) == null ? void 0 : _a.call(props, event, props);
                        },
                        className: (0, import_classnames13.default)("rce-mbox-title", {
                          "rce-mbox-title--clear": props.type === "text"
                        }),
                        children: [
                          props.avatar && props.title && /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(
                            Avatar_default,
                            {
                              title: props.title,
                              size: "xsmall",
                              letterItem: props.letterItem,
                              src: props.avatar
                            }
                          ),
                          props.title && /* @__PURE__ */ (0, import_jsx_runtime22.jsx)("span", { children: props.title })
                        ]
                      }
                    ),
                    props.reply ? /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(
                      ReplyMessage_default,
                      __spreadValues({
                        onClick: (e) => {
                          var _a;
                          return (_a = props.onReplyMessage) == null ? void 0 : _a.call(props, e, props);
                        }
                      }, props.reply)
                    ) : null,
                    props.forwarded ? /* @__PURE__ */ (0, import_jsx_runtime22.jsx)("div", { className: "rce-mbox-forwarded-message", children: /* @__PURE__ */ (0, import_jsx_runtime22.jsxs)("div", { className: "rce-mbox-forwarded-message-inner", children: [
                      /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(
                        import_md4.MdReply,
                        {
                          size: 15,
                          style: { padding: 0 },
                          className: "reverse-icon-horizontal"
                        }
                      ),
                      (props == null ? void 0 : props.forwardedMessageText) && /* @__PURE__ */ (0, import_jsx_runtime22.jsx)("i", { children: props.forwardedMessageText })
                    ] }) }) : null,
                    props.type === "text" && /* @__PURE__ */ (0, import_jsx_runtime22.jsxs)(
                      "div",
                      {
                        className: (0, import_classnames13.default)(
                          "rce-mbox-text",
                          (props == null ? void 0 : props.position) === "right" ? "right" : "left",
                          {
                            "rce-mbox-text-retracted": props.retracted
                          }
                        ),
                        children: [
                          !props.forwarded && props.retracted && /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(import_md4.MdEdit, {}),
                          props.text
                        ]
                      }
                    ),
                    props.type === "location" && /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(LocationMessage_default, __spreadValues({}, props)),
                    props.type === "photo" && /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(PhotoMessage_default, __spreadValues({}, props)),
                    props.type === "video" && /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(VideoMessage_default, __spreadValues({}, props)),
                    props.type === "file" && /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(FileMessage_default, __spreadValues({}, props)),
                    props.type === "meeting" && /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(MeetingMessage_default, __spreadValues({}, props)),
                    props.type === "audio" && /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(AudioMessage_default, __spreadValues({}, props)),
                    props.type === "meetingLink" && (props == null ? void 0 : props.actionButtons) && /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(
                      MeetingLink_default,
                      __spreadProps(__spreadValues({}, props), {
                        text: (props == null ? void 0 : props.meetingLinkText) || "Join Meeting",
                        actionButtons: props.actionButtons,
                        meetingID: props.meetingID
                      })
                    ),
                    /* @__PURE__ */ (0, import_jsx_runtime22.jsxs)(
                      "div",
                      {
                        title: props.statusTitle,
                        className: (0, import_classnames13.default)(
                          "rce-mbox-time",
                          { "rce-mbox-time-block": thatAbsoluteTime },
                          { "non-copiable": !props.copiableDate }
                        ),
                        "data-text": props.copiableDate ? void 0 : dateText,
                        children: [
                          props.copiableDate && props.date !== void 0 && relativeDateFormat(props.date),
                          (props == null ? void 0 : props.status) && /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(MessageStatus, { status: props.status })
                        ]
                      }
                    ),
                    (props == null ? void 0 : props.reactions) && /* @__PURE__ */ (0, import_jsx_runtime22.jsx)(Reactions, { reactions: props.reactions })
                  ]
                }
              )
            ]
          }
        )
      ]
    }
  );
};
var MessageBox_default = MessageBox;

// src/ChatItem/ChatItem.tsx
var import_classnames15 = __toESM(require("classnames"));
var import_md5 = require("react-icons/md");
var import_fa5 = require("react-icons/fa");
var import_react6 = require("react");

// src/Badge/Badge.tsx
var import_classnames14 = __toESM(require("classnames"));
var import_jsx_runtime23 = require("react/jsx-runtime");
var Badge = (props) => {
  var _a, _b;
  const { rounded = true } = props;
  return /* @__PURE__ */ (0, import_jsx_runtime23.jsx)(
    "span",
    {
      style: __spreadProps(__spreadValues({}, props.style), {
        color: (props == null ? void 0 : props.color) || "var(--rce-color-white)",
        backgroundColor: (props == null ? void 0 : props.backgroundColor) || "var(--rce-color-red)",
        fontSize: (props == null ? void 0 : props.size) || 11,
        aspectRatio: rounded ? "1/1" : void 0,
        borderRadius: rounded ? "100%" : "5px",
        position: (props == null ? void 0 : props.position) ? "absolute" : void 0
      }),
      className: (0, import_classnames14.default)(
        "rce-badge",
        props.className,
        props.position ? (_a = props.position) == null ? void 0 : _a.split("-").join(" ") : void 0
      ),
      children: (props == null ? void 0 : props.value) ? (_b = props == null ? void 0 : props.value) == null ? void 0 : _b.toString() : null
    }
  );
};
var Badge_default = Badge;

// src/ChatItem/ChatItem.tsx
var import_jsx_runtime24 = require("react/jsx-runtime");
var import_react7 = require("react");
var ChatItem = (_a) => {
  var _b = _a, {
    date = /* @__PURE__ */ new Date()
  } = _b, props = __objRest(_b, [
    "date"
  ]);
  var _a2, _b2, _c, _d;
  const [isExpanded, setIsExpanded] = (0, import_react6.useState)(
    props.expanded || false
  );
  function getStatusItem() {
    var _a3;
    if ((props == null ? void 0 : props.statusColorType) === "badge") {
      return /* @__PURE__ */ (0, import_jsx_runtime24.jsx)(
        Badge_default,
        {
          backgroundColor: props == null ? void 0 : props.statusColor,
          value: props == null ? void 0 : props.statusText,
          position: "top-right"
        }
      );
    }
    if ((props == null ? void 0 : props.statusColorType) === "encircle") {
      return /* @__PURE__ */ (0, import_jsx_runtime24.jsx)(
        "span",
        {
          className: "rce-citem-status encircle",
          style: {
            borderColor: (_a3 = props == null ? void 0 : props.statusColor) != null ? _a3 : "var(--rce-color-green)"
          }
        }
      );
    }
    return null;
  }
  return /* @__PURE__ */ (0, import_jsx_runtime24.jsx)("div", { className: (0, import_classnames15.default)("rce-container-citem", props.className), children: /* @__PURE__ */ (0, import_jsx_runtime24.jsxs)("div", { className: "rce-citem", children: [
    /* @__PURE__ */ (0, import_jsx_runtime24.jsxs)(
      "div",
      {
        className: (0, import_classnames15.default)("rce-citem-avatar", {
          "rce-citem-status-encircle": (props == null ? void 0 : props.statusColorType) === "encircle"
        }),
        children: [
          /* @__PURE__ */ (0, import_jsx_runtime24.jsx)(
            Avatar_default,
            {
              src: props == null ? void 0 : props.avatar,
              alt: props.alt,
              title: props.title,
              className: (props == null ? void 0 : props.statusColorType) === "encircle" ? "rce-citem-avatar-encircle-status" : void 0,
              size: props.avatarSize || "default",
              letterItem: props.letterItem,
              sideElement: getStatusItem(),
              onError: props.onAvatarError,
              type: (0, import_classnames15.default)("circle", {
                flexible: (props == null ? void 0 : props.avatarFlexible) === true
              })
            }
          ),
          ((_a2 = props == null ? void 0 : props.subList) == null ? void 0 : _a2.length) && /* @__PURE__ */ (0, import_jsx_runtime24.jsxs)(import_jsx_runtime24.Fragment, { children: [
            /* @__PURE__ */ (0, import_jsx_runtime24.jsx)(
              Button_default,
              {
                link: true,
                className: "rce-citem-expand-button",
                onClick: () => setIsExpanded(!isExpanded),
                icon: {
                  component: isExpanded ? /* @__PURE__ */ (0, import_jsx_runtime24.jsx)(import_fa5.FaArrowUp, {}) : /* @__PURE__ */ (0, import_jsx_runtime24.jsx)(import_fa5.FaArrowDown, {})
                }
              }
            ),
            /* @__PURE__ */ (0, import_jsx_runtime24.jsx)(
              "div",
              {
                className: "mce-citem-sublist",
                style: { display: props.expanded ? "block" : "none" },
                children: (_b2 = props.subList) == null ? void 0 : _b2.map((sub, i) => /* @__PURE__ */ (0, import_react7.createElement)(
                  ChatItem,
                  __spreadProps(__spreadValues({}, sub), {
                    className: "subitem",
                    avatarSize: "xsmall",
                    key: `subitem-${i.toString()}`
                  })
                ))
              }
            )
          ] })
        ]
      }
    ),
    /* @__PURE__ */ (0, import_jsx_runtime24.jsxs)("div", { className: "rce-citem-body", children: [
      /* @__PURE__ */ (0, import_jsx_runtime24.jsxs)("div", { className: "rce-citem-body--top", children: [
        /* @__PURE__ */ (0, import_jsx_runtime24.jsx)("div", { className: "rce-citem-body--top-title", children: props.title }),
        /* @__PURE__ */ (0, import_jsx_runtime24.jsx)("div", { className: "rce-citem-body--top-time", children: date && (props.dateString || relativeDateFormat(date)) })
      ] }),
      /* @__PURE__ */ (0, import_jsx_runtime24.jsxs)("div", { className: "rce-citem-body--bottom", children: [
        /* @__PURE__ */ (0, import_jsx_runtime24.jsx)("div", { className: "rce-citem-body--bottom-title", children: props.subtitle }),
        /* @__PURE__ */ (0, import_jsx_runtime24.jsxs)("div", { className: "rce-citem-body--bottom-elements", children: [
          /* @__PURE__ */ (0, import_jsx_runtime24.jsxs)(
            "div",
            {
              className: "rce-citem-body--bottom-tools",
              onMouseEnter: props == null ? void 0 : props.handleOnMouseEnter,
              onMouseLeave: props == null ? void 0 : props.handleOnMouseLeave,
              children: [
                props.showMute ? /* @__PURE__ */ (0, import_jsx_runtime24.jsx)(
                  Button_default,
                  {
                    link: true,
                    className: "rce-citem-body--bottom-tools-item",
                    onClick: (ev) => {
                      var _a3;
                      return (_a3 = props == null ? void 0 : props.onMuteToggle) == null ? void 0 : _a3.call(props, ev, props);
                    },
                    icon: {
                      component: (props == null ? void 0 : props.muted) ? /* @__PURE__ */ (0, import_jsx_runtime24.jsx)(import_md5.MdVolumeOff, {}) : /* @__PURE__ */ (0, import_jsx_runtime24.jsx)(import_md5.MdVolumeUp, {})
                    }
                  }
                ) : null,
                (props == null ? void 0 : props.showVideoCall) ? /* @__PURE__ */ (0, import_jsx_runtime24.jsx)(
                  Button_default,
                  {
                    link: true,
                    className: "rce-citem-body--bottom-tools-item",
                    onClick: (ev) => {
                      var _a3;
                      return (_a3 = props == null ? void 0 : props.onVideoCall) == null ? void 0 : _a3.call(props, ev, props);
                    },
                    icon: { component: /* @__PURE__ */ (0, import_jsx_runtime24.jsx)(import_md5.MdVideoCall, {}) }
                  }
                ) : null
              ]
            }
          ),
          /* @__PURE__ */ (0, import_jsx_runtime24.jsx)("div", { className: "rce-citem-body--bottom-tools-item-hidden-hover", children: (props == null ? void 0 : props.showMute) && (props == null ? void 0 : props.muted) && /* @__PURE__ */ (0, import_jsx_runtime24.jsx)(
            Button_default,
            {
              link: true,
              className: "rce-citem-body--bottom-tools-item",
              onClick: (e) => {
                var _a3;
                return (_a3 = props == null ? void 0 : props.onMuteToggle) == null ? void 0 : _a3.call(props, e, props);
              },
              children: /* @__PURE__ */ (0, import_jsx_runtime24.jsx)(import_md5.MdVolumeOff, {})
            }
          ) }),
          (props == null ? void 0 : props.unread) ? /* @__PURE__ */ (0, import_jsx_runtime24.jsx)(
            Badge_default,
            {
              className: "rce-citem-body--bottom-status",
              value: props.unread
            }
          ) : null,
          (_d = (_c = props == null ? void 0 : props.customStatusComponents) == null ? void 0 : _c.map(
            (el, index) => {
              return (0, import_react6.cloneElement)(el, { key: index.toString() });
            }
          )) != null ? _d : null
        ] })
      ] })
    ] }, "rce-citem-body")
  ] }) });
};
var ChatItem_default = ChatItem;

// src/ChatList/ChatList.tsx
var import_classnames16 = __toESM(require("classnames"));
var import_jsx_runtime25 = require("react/jsx-runtime");
var ChatList = (_a) => {
  var _b = _a, { dataSource } = _b, props = __objRest(_b, ["dataSource"]);
  var _a2;
  return /* @__PURE__ */ (0, import_jsx_runtime25.jsx)("div", { className: (0, import_classnames16.default)("rce-container-clist", props.className), children: (_a2 = dataSource == null ? void 0 : dataSource.map((el, index) => /* @__PURE__ */ (0, import_jsx_runtime25.jsx)(ChatItem_default, __spreadValues({}, el), `chat-item-${index.toString()}`))) != null ? _a2 : /* @__PURE__ */ (0, import_jsx_runtime25.jsx)(Loader_default, {}) });
};
var ChatList_default = ChatList;

// src/MessageList/MessageList.tsx
var import_react8 = require("react");
var import_classnames17 = __toESM(require("classnames"));
var import_md6 = require("react-icons/md");
var import_jsx_runtime26 = require("react/jsx-runtime");
var import_react9 = require("react");
var MessageList = (_a) => {
  var _b = _a, {
    reference,
    lockable = false,
    toBottomHeight = 300,
    downButton = null
  } = _b, props = __objRest(_b, [
    "reference",
    "lockable",
    "toBottomHeight",
    "downButton"
  ]);
  var _a2;
  const [scrollBottom, setScrollBottom] = (0, import_react8.useState)(0);
  const [scrollButton, setScrollButton] = (0, import_react8.useState)(false);
  const prevProps = (0, import_react8.useRef)(props);
  const checkScroll = () => {
    const e = reference;
    if (!e || !e.current) return;
    if (toBottomHeight === "100%" || toBottomHeight && scrollBottom < Number(toBottomHeight)) {
      e.current.scrollTop = e.current.scrollHeight;
    } else {
      if (lockable) {
        e.current.scrollTop = e.current.scrollHeight - e.current.offsetHeight - scrollBottom;
      }
    }
  };
  (0, import_react8.useEffect)(() => {
    var _a3;
    if (!(reference == null ? void 0 : reference.current)) return;
    if (((_a3 = prevProps.current) == null ? void 0 : _a3.dataSource.length) !== props.dataSource.length) {
      setScrollBottom(getBottom(reference.current));
      checkScroll();
    }
    prevProps.current = props;
  }, [checkScroll, reference, props]);
  const getBottom = (e) => {
    if (e) {
      return e.scrollHeight - e.scrollTop - e.offsetHeight;
    }
    return 0;
  };
  const onScroll = (e) => {
    const element = e == null ? void 0 : e.currentTarget;
    const bottom = getBottom(element);
    setScrollBottom(bottom);
    if (toBottomHeight === "100%" || toBottomHeight && bottom > Number(toBottomHeight)) {
      if (!scrollButton) {
        setScrollButton(true);
        setScrollBottom(bottom);
      }
    } else {
      if (scrollButton) {
        setScrollButton(false);
        setScrollBottom(bottom);
      }
    }
    if (props.onScroll instanceof Function) {
      props.onScroll(e);
    }
  };
  const toBottom = (e) => {
    if (!(reference == null ? void 0 : reference.current)) return;
    const el = reference.current;
    el.scrollTop = el.scrollHeight;
    if (props.onDownButtonClick instanceof Function) props.onDownButtonClick(e);
  };
  return /* @__PURE__ */ (0, import_jsx_runtime26.jsxs)(
    "div",
    __spreadProps(__spreadValues({}, props.customProps), {
      className: (0, import_classnames17.default)(["rce-container-mlist", props.className]),
      children: [
        !!props.children && props.isShowChild && props.children,
        /* @__PURE__ */ (0, import_jsx_runtime26.jsx)(
          "div",
          {
            ref: reference,
            onScroll: (e) => onScroll(e),
            className: "rce-mlist",
            children: (_a2 = props.dataSource) == null ? void 0 : _a2.map((x, i) => /* @__PURE__ */ (0, import_react9.createElement)(MessageBox_default, __spreadProps(__spreadValues(__spreadValues({}, x), props), { key: `message-${i.toString()}` })))
          }
        ),
        scrollButton && toBottomHeight !== "100%" && /* @__PURE__ */ (0, import_jsx_runtime26.jsx)(
          Button_default,
          {
            circle: true,
            className: "rce-mlist-down-button",
            onClick: (e) => toBottom(e),
            color: "var(--rce-color-gray)",
            backgroundColor: "var(--rce-color-white)",
            icon: { component: /* @__PURE__ */ (0, import_jsx_runtime26.jsx)(import_md6.MdKeyboardArrowDown, { size: 40 }) },
            style: { padding: 2 },
            children: (props == null ? void 0 : props.downButtonBadge) ? /* @__PURE__ */ (0, import_jsx_runtime26.jsx)(
              Badge_default,
              {
                className: "rce-mlist-down-button--badge",
                value: props == null ? void 0 : props.downButtonBadge
              }
            ) : void 0
          }
        )
      ]
    })
  );
};
var MessageList_default = MessageList;

// src/MeetingList/MeetingList.tsx
var import_classnames18 = __toESM(require("classnames"));
var import_jsx_runtime27 = require("react/jsx-runtime");
var import_react10 = require("react");
var MeetingList = (props) => {
  var _a;
  return /* @__PURE__ */ (0, import_jsx_runtime27.jsx)(
    "div",
    {
      ref: props.cmpRef,
      className: (0, import_classnames18.default)("rce-container-mtlist", props.className),
      children: (_a = props.dataSource) == null ? void 0 : _a.map((x, i) => /* @__PURE__ */ (0, import_react10.createElement)(MeetingItem_default, __spreadProps(__spreadValues({}, x), { key: i })))
    }
  );
};
var MeetingList_default = MeetingList;

// src/Input/Input.tsx
var import_react11 = require("react");
var import_classnames19 = __toESM(require("classnames"));
var import_md7 = require("react-icons/md");
var import_jsx_runtime28 = require("react/jsx-runtime");
var Input = (props) => {
  var _b, _c;
  const _a = props, {
    type = "text",
    multiline = false,
    minHeight = 25,
    maxHeight = 200,
    autoHeight = true,
    autofocus = false,
    clearButton = true,
    placeholder = "Type here...",
    maxlength = 200,
    onMaxLengthExceed = () => console.warn("The maxlength has been exceeded"),
    value: propValue = "",
    style = {}
  } = _a, rest = __objRest(_a, [
    "type",
    "multiline",
    "minHeight",
    "maxHeight",
    "autoHeight",
    "autofocus",
    "clearButton",
    "placeholder",
    "maxlength",
    "onMaxLengthExceed",
    "value",
    "style"
  ]);
  const [value, setValue] = (0, import_react11.useState)(
    propValue || rest.defaultValue || ""
  );
  (0, import_react11.useEffect)(() => {
    var _a2, _b2;
    if (autofocus) (_b2 = (_a2 = rest.reference) == null ? void 0 : _a2.current) == null ? void 0 : _b2.focus();
  }, [autofocus, (_c = (_b = rest.reference) == null ? void 0 : _b.current) == null ? void 0 : _c.focus]);
  (0, import_react11.useEffect)(() => {
    setValue(propValue);
  }, [propValue]);
  const onSubmitEvent = (ev) => {
    ev.preventDefault();
    setValue("");
    if (rest.onSubmit instanceof Function) rest.onSubmit(ev);
  };
  const onChangeEvent = (ev) => {
    var _a2;
    const el = ev.target;
    let newValue = el.value;
    if (newValue) {
      setValue(newValue);
    }
    if (multiline) {
      if (autoHeight) {
        if (style.height !== `${minHeight}px`) {
          style.height = `${minHeight}px`;
        }
        let height = "";
        if (el.scrollHeight <= maxHeight) height = `${el.scrollHeight}px`;
        else height = `${maxHeight}px`;
        if (style.height !== height) {
          style.height = height;
        }
      }
    }
    if (maxlength && (el.value || "").length > maxlength) {
      if (onMaxLengthExceed) onMaxLengthExceed();
      if ((_a2 = rest.reference) == null ? void 0 : _a2.current) {
        newValue = newValue.substring(0, maxlength);
        rest.reference.current.value = newValue;
        setValue(newValue);
      }
      return;
    }
  };
  const clear = () => {
    var _a2;
    if ((_a2 = rest.reference) == null ? void 0 : _a2.current) {
      rest.reference.current.value = "";
    }
    setValue("");
  };
  return /* @__PURE__ */ (0, import_jsx_runtime28.jsxs)(
    "form",
    {
      onSubmit: onSubmitEvent,
      className: (0, import_classnames19.default)("rce-container-input", rest.className),
      style,
      children: [
        rest.leftButtons && /* @__PURE__ */ (0, import_jsx_runtime28.jsx)("div", { className: "rce-input-buttons", children: rest.leftButtons }),
        /* @__PURE__ */ (0, import_jsx_runtime28.jsxs)("div", { className: "rce-input-content w-full relative", children: [
          !multiline ? /* @__PURE__ */ (0, import_jsx_runtime28.jsx)(
            "input",
            __spreadProps(__spreadValues({}, rest), {
              name: "chat-input",
              style: rest.inputStyle,
              ref: rest.reference,
              type,
              className: "rce-input w-full",
              placeholder,
              value,
              onChange: (e) => onChangeEvent(e)
            })
          ) : /* @__PURE__ */ (0, import_jsx_runtime28.jsx)(
            "textarea",
            __spreadProps(__spreadValues({}, rest), {
              ref: rest.reference,
              className: (0, import_classnames19.default)("rce-input", "rce-input-textarea"),
              placeholder,
              style: rest.inputStyle,
              onChange: (e) => onChangeEvent(e),
              children: value
            })
          ),
          clearButton && value && /* @__PURE__ */ (0, import_jsx_runtime28.jsx)(
            Button_default,
            {
              className: "rce-input-clear",
              onClick: clear,
              backgroundColor: "transparent",
              style: {
                position: "absolute",
                zIndex: 1,
                right: 0,
                top: 0,
                opacity: 0.3
              },
              icon: {
                component: /* @__PURE__ */ (0, import_jsx_runtime28.jsx)(import_md7.MdClear, { color: "var(--rce-color-gray)", size: 20 })
              }
            }
          )
        ] }),
        rest.rightButtons && /* @__PURE__ */ (0, import_jsx_runtime28.jsx)("div", { className: "rce-input-buttons", children: rest.rightButtons })
      ]
    }
  );
};
var Input_default = Input;

// src/Navbar/Navbar.tsx
var import_classnames20 = __toESM(require("classnames"));
var import_jsx_runtime29 = require("react/jsx-runtime");
var Navbar = (_a) => {
  var _b = _a, {
    type = "default",
    style = {
      width: "100%"
    }
  } = _b, props = __objRest(_b, [
    "type",
    "style"
  ]);
  return /* @__PURE__ */ (0, import_jsx_runtime29.jsxs)(
    "div",
    {
      className: (0, import_classnames20.default)("rce-navbar", type, props.className),
      style,
      children: [
        /* @__PURE__ */ (0, import_jsx_runtime29.jsx)("div", { className: "rce-navbar-item rce-navbar-item__left", children: props.left }),
        /* @__PURE__ */ (0, import_jsx_runtime29.jsx)("div", { className: "rce-navbar-item rce-navbar-item__center", children: props.center }),
        /* @__PURE__ */ (0, import_jsx_runtime29.jsx)("div", { className: "rce-navbar-item rce-navbar-item__right", children: props.right })
      ]
    }
  );
};
var Navbar_default = Navbar;

// src/SideBar/SideBar.tsx
var import_classnames21 = __toESM(require("classnames"));
var import_jsx_runtime30 = require("react/jsx-runtime");
var SideBar = (_a) => {
  var _b = _a, {
    type = "default",
    style = {}
  } = _b, props = __objRest(_b, [
    "type",
    "style"
  ]);
  return /* @__PURE__ */ (0, import_jsx_runtime30.jsxs)(
    "div",
    {
      className: (0, import_classnames21.default)("rce-sbar", type, props == null ? void 0 : props.className),
      style,
      children: [
        /* @__PURE__ */ (0, import_jsx_runtime30.jsx)("div", { className: "rce-sbar-item", children: props == null ? void 0 : props.top }),
        /* @__PURE__ */ (0, import_jsx_runtime30.jsx)("div", { className: "rce-sbar-item rce-sbar-item__center", children: props == null ? void 0 : props.center }),
        /* @__PURE__ */ (0, import_jsx_runtime30.jsx)("div", { className: "rce-sbar-item", children: props == null ? void 0 : props.bottom })
      ]
    }
  );
};
var SideBar_default = SideBar;

// src/Popup/Popup.tsx
var import_classnames22 = __toESM(require("classnames"));
var import_jsx_runtime31 = require("react/jsx-runtime");
var Popup2 = (props) => {
  var _a, _b, _c, _d, _e, _f, _g, _h, _i, _j, _k, _l, _m, _n, _o;
  if (props.show === true)
    return /* @__PURE__ */ (0, import_jsx_runtime31.jsx)(
      "div",
      {
        className: (0, import_classnames22.default)("rce-popup-wrapper", props.type, props.className),
        style: {
          backgroundColor: (_a = props.wrapperColor) != null ? _a : "rgb(0 0 0 / 75%)"
        },
        children: /* @__PURE__ */ (0, import_jsx_runtime31.jsxs)("div", { className: "rce-popup", children: [
          ((_b = props.popup) == null ? void 0 : _b.renderHeader) ? /* @__PURE__ */ (0, import_jsx_runtime31.jsx)("div", { className: "rce-popup-header text-extrabold text-2xl", children: (_c = props.popup) == null ? void 0 : _c.renderHeader }) : /* @__PURE__ */ (0, import_jsx_runtime31.jsxs)("div", { className: "rce-popup-header text-extrabold text-2xl", children: [
            /* @__PURE__ */ (0, import_jsx_runtime31.jsx)("span", { children: (_d = props.popup) == null ? void 0 : _d.header }),
            ((_e = props.popup) == null ? void 0 : _e.header) && ((_g = (_f = props.popup) == null ? void 0 : _f.headerButtons) == null ? void 0 : _g.map((x, i) => /* @__PURE__ */ (0, import_jsx_runtime31.jsx)(Button_default, __spreadValues({}, x), i.toString())))
          ] }),
          /* @__PURE__ */ (0, import_jsx_runtime31.jsx)(
            "div",
            {
              className: "rce-popup-content",
              style: { color: (_h = props.popup) == null ? void 0 : _h.color },
              children: ((_i = props.popup) == null ? void 0 : _i.renderContent) ? (_j = props.popup) == null ? void 0 : _j.renderContent : (_k = props.popup) == null ? void 0 : _k.text
            }
          ),
          /* @__PURE__ */ (0, import_jsx_runtime31.jsx)("div", { className: "rce-popup-footer", children: ((_l = props.popup) == null ? void 0 : _l.renderFooter) ? (_m = props.popup) == null ? void 0 : _m.renderFooter : (_o = (_n = props.popup) == null ? void 0 : _n.footerButtons) == null ? void 0 : _o.map((x, i) => /* @__PURE__ */ (0, import_jsx_runtime31.jsx)(Button_default, __spreadValues({}, x), i.toString())) })
        ] })
      }
    );
  return null;
};
var Popup_default = Popup2;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  AudioMessage,
  Avatar,
  Button,
  ChatItem,
  ChatList,
  Dropdown,
  FileMessage,
  Input,
  Loader,
  LocationMessage,
  MeetingItem,
  MeetingLink,
  MeetingList,
  MeetingMessage,
  MessageBox,
  MessageList,
  Navbar,
  PhotoMessage,
  Popup,
  ReplyMessage,
  SideBar,
  SystemMessage,
  VideoMessage
});
